/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.entity;

import com.baomidou.mybatisplus.annotation.TableName;

import java.io.Serializable;

import io.swagger.annotations.ApiModelProperty;
import org.springblade.core.mp.base.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 实体类
 *
 * @author BladeX
 * @since 2022-06-29
 */
@Data
@TableName("u_assessment_user")
@EqualsAndHashCode(callSuper = true)
public class AssessmentUser extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * user_opinion_flow表id
     */
    @ApiModelProperty("分页上的uoFlowId")
    private Long userOpinionFlowId;
    /**
     * 考核金额（元）
     */
    @ApiModelProperty("考核金额（元），类型的值")
    private String assessmentMoney;
    /**
     * 考核原因
     */
    @ApiModelProperty("考核原因，类型的明文")
    private String assessmentContent;

    @ApiModelProperty("被考核人ID")
    private String assessmentUser;

    @ApiModelProperty("考核类型，类型的ID")
    private String assessmentType;

}
