/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.entity;

import com.baomidou.mybatisplus.annotation.TableName;

import java.io.Serializable;
import java.time.LocalDateTime;

import io.swagger.annotations.ApiModelProperty;
import org.springblade.core.mp.base.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 实体类
 *
 * @author BladeX
 * @since 2022-05-23
 */
@Data
@TableName("u_construction_ledger")
@EqualsAndHashCode(callSuper = true)
public class ConstructionLedger extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 施工桩号
     */
	@ApiModelProperty("施工桩号")
    private String station;
    /**
     * 施工部位
     */
	@ApiModelProperty("施工部位")
    private String site;
    /**
     * 施工开始时间
     */
	@ApiModelProperty("施工开始时间")
    private LocalDateTime siteStartTime;
    /**
     * 施工结束时间
     */
	@ApiModelProperty("施工结束时间")
    private LocalDateTime siteEndTime;
    /**
     * 检测开始时间
     */
	@ApiModelProperty("检测开始时间")
    private LocalDateTime detectionStartTime;
    /**
     * 检测结束时间
     */
	@ApiModelProperty("检测结束时间")
    private LocalDateTime detectionEndTime;
    /**
     * 设计方量
     */
	@ApiModelProperty("设计方量")
    private String designVolume;
    /**
     * 实际方量
     */
	@ApiModelProperty("实际方量")
    private String actualVolume;
    /**
     * 是否含混凝土
     */
	@ApiModelProperty("是否含混凝土")
    private Integer isBeton;
    /**
     * wbs节点ID
     */
    private Long wbsId;
    /**
     * 合同段ID
     */
    @ApiModelProperty("合同段ID")
    private Long contractId;
    /**
     * 项目ID
     */
    @ApiModelProperty("项目ID")
    private Long projectId;

}
