/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.entity;

import com.baomidou.mybatisplus.annotation.TableName;

import java.io.Serializable;

import io.swagger.annotations.ApiModelProperty;
import org.springblade.core.mp.base.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 日志通用表实体类
 *
 * @author BladeX
 * @since 2022-06-15
 */
@Data
@TableName("u_contract_log")
@EqualsAndHashCode(callSuper = true)
public class ContractLog extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 项目ID
     */
    @ApiModelProperty("项目ID")
    private Long projectId;
    /**
     * 合同段ID
     */
    @ApiModelProperty("合同段ID")
    private Long contractId;
    /**
     * 所填报的节点类型ID
     */
    @ApiModelProperty("所填报的节点类型ID")
    private Long wbsNodeId;
    /**
     * 日志类型
     */
    @ApiModelProperty("日志类型")
    private Integer wbsNodeType;
    /**
     * 填报时间、施工时间
     */
    @ApiModelProperty("填报时间、施工时间")
    private String recordTime;
    /**
     * 编号
     */
    @ApiModelProperty("编号")
    private String recordNumber;

    @ApiModelProperty("工程桩号")
    private String projectPileno;

    @ApiModelProperty("工程部位")
    private String projectPart;
    /**
     * 数据ID
     */
    private Long dataId;

    @ApiModelProperty("填报人姓名")
    private String createUserName;


}
