/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.entity;

import com.baomidou.mybatisplus.annotation.TableName;

import io.swagger.annotations.ApiModelProperty;
import org.springblade.core.mp.base.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.Date;

/**
 * 首件信息记录表实体类
 *
 * @author BladeX
 * @since 2022-06-20
 */
@Data
@TableName("u_first_information")
@EqualsAndHashCode(callSuper = true)
public class FirstInformation extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 节点ID
     */
    @ApiModelProperty("节点ID")
    private Long wbsNodeId;

    /**
     * 文件名称
     */
    @ApiModelProperty("文件名称")
    private String fileName;

    /**
     * 填报时间
     */
    @ApiModelProperty("填报时间")
    private String reportTime;

    /**
     * 数据ID，通过这个字段去寻找相关联的数据
     */
    private Long dataId;

    /**
     * 流程批次
     */
    @ApiModelProperty("流程批次")
    private Integer reportNumber;

    /**
     * 创建人姓名
     */
    @ApiModelProperty("创建人姓名")
    private String createUserName;

    /**
     * 流程ID
     */
    @ApiModelProperty("流程ID")
    private String taskId;

    /**
     * 1施工2质检
     */
    @ApiModelProperty("1施工2质检")
    private Integer classify;

    public FirstInformation(String fileName, Long wbsNodeId, Integer reportNumber, Integer status, Long userId, String userName, Long deptId){
        this.fileName = fileName;
        this.wbsNodeId = wbsNodeId;
        this.reportNumber = reportNumber;
        this.setStatus(status);
        this.setCreateUser(userId);
        this.createUserName = userName;
        this.setDataId(deptId);
        this.setCreateTime(new Date());
    }

    public FirstInformation(){}

}
