/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.entity;

import com.baomidou.mybatisplus.annotation.TableName;

import java.io.Serializable;
import java.util.Date;

import org.springblade.core.mp.base.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springblade.core.secure.utils.AuthUtil;

/**
 * 实体类
 *
 * @author BladeX
 * @since 2022-07-01
 */
@Data
@TableName("u_fixed_flow_link")
@EqualsAndHashCode(callSuper = true)
public class FixedFlowLink extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 固定流程ID
     */
    private Long fixedFlowId;
    /**
     * 流程环节
     */
    private String fixedFlowLink;
    /**
     * 环节处理人ID
     */
    private Long fixedFlowLinkUser;
    /**
     * 环节处理人姓名
     */
    private String fixedFlowLinkUserName;
    /**
     * 环节顺序
     */
    private Integer fixedFlowLinkSort;
    /**
     * 角色ID
     */
    private Long fixedFlowRole;
    /**
     * 角色名称
     */
    private String fixedFlowRoleName;
    private Long projectId;
    private Long contractId;

    public FixedFlowLink(){}

    public FixedFlowLink(String fixedFlowLinkUserName, String fixedFlowLinkUser, Long projectId, Long contractId, Long fixedFlowId, Integer sort){
        this.fixedFlowLinkUserName = fixedFlowLinkUserName;
        this.fixedFlowLinkUser = Long.parseLong(fixedFlowLinkUser);
        this.projectId = projectId;
        this.contractId = contractId;
        this.fixedFlowId = fixedFlowId;
        this.fixedFlowLinkSort = sort;
        this.setCreateUser(AuthUtil.getUserId());
        this.setCreateDept(AuthUtil.getDeptId().contains(",") ? Long.parseLong(AuthUtil.getDeptId().split(",")[0]) : Long.parseLong(AuthUtil.getDeptId()));
        this.setCreateTime(new Date());
    }

}
