/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.entity;

import com.baomidou.mybatisplus.annotation.TableName;

import java.io.Serializable;
import java.time.LocalDateTime;

import io.swagger.annotations.ApiModelProperty;
import org.springblade.core.mp.base.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 实体类
 *
 * @author BladeX
 * @since 2022-05-24
 */
@Data
@TableName("u_image_classification_file")
@EqualsAndHashCode(callSuper = true)
public class ImageClassificationFile extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 分类ID，m_image_classification_config表主键
     */
    @ApiModelProperty("分类ID")
    private Long classifyId;
    /**
     * 项目ID
     */
    @ApiModelProperty("项目ID")
    private Long projectId;
    /**
     * 合同段ID
     */
    @ApiModelProperty("合同段ID")
    private Long contractId;
	/**
	 * 工程节点ID，可为空
	 */
    @ApiModelProperty("划分节点ID")
	private Long wbsId;
    /**
     * 文件大小
     */
    @ApiModelProperty("文件大小")
    private String fileSize;
    /**
     * 文件名称
     */
    @ApiModelProperty("文件名称")
    private String fileName;
    /**
     * 题名
     */
    @ApiModelProperty("题名")
    private String title;
    /**
     * 文件类型，视频格式1，图片格式2
     */
    @ApiModelProperty("文件类型，视频格式1，图片格式2")
    private Integer type;
    /**
     * 文件所在路径
     */
    @ApiModelProperty("文件所在路径")
    private String imageUrl;
    /**
     * 拍摄者
     */
    @ApiModelProperty("拍摄者")
    private String shootingUser;
    /**
     * 拍摄时间
     */
    @ApiModelProperty("拍摄时间")
    private LocalDateTime shootingTime;
    /**
     * 上传日期
     */
    @ApiModelProperty("上传日期")
    private String uploadTime;
    /**
     * 照片号，视频格式不填
     */
    @ApiModelProperty("照片号，视频格式不填")
    private String photoCode;
    /**
     * 底片号，视频格式不填
     */
    @ApiModelProperty("底片号，视频格式不填")
    private String filmCode;
    /**
     * 参见号，视频格式不填
     */
    @ApiModelProperty("参见号，视频格式不填")
    private String seeAlsoCode;
    /**
     * 文字说明
     */
    @ApiModelProperty("文字说明")
    private String textContent;


}
