package org.springblade.business.entity;

import com.baomidou.mybatisplus.annotation.TableName;

import io.swagger.annotations.ApiModelProperty;
import org.springblade.core.mp.base.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 实体类
 *
 * @author BladeX
 * @since 2022-06-08
 */
@Data
@TableName("u_information_query")
@EqualsAndHashCode(callSuper = true)
public class InformationQuery extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 文件名称
     */
	@ApiModelProperty("文件名称")
    private String name;
    /**
     * 文件编号
     */
	@ApiModelProperty("文件编号")
    private String number;
    /**
     * 与m_wbs_tree_contract的dept_category一致
     */
	@ApiModelProperty("类型")
    private Integer category;
    /**
     * 上级节点ID
     */
	@ApiModelProperty("上级节点ID")
    private Long parentId;
    /**
     * 项目ID
     */
	@ApiModelProperty("项目ID")
    private Long projectId;
    /**
     * 合同段ID
     */
	@ApiModelProperty("合同段ID")
    private Long contractId;
    /**
     * 1施工2质检
     */
	@ApiModelProperty("1施工2质检")
    private Integer classify;
    /**
     * 节点ID
     */
    @ApiModelProperty("节点ID")
    private Long wbsId;
    /**
     * 是否是试验资料，1是试验
     */
	@ApiModelProperty("是否是试验资料，1是试验")
    private Integer isExperiment;
    /**
     * 数据ID
     */
	@ApiModelProperty("数据ID")
    private Long dataId;
    /**
     * 施工资料的流程ID
     */
	@ApiModelProperty("资料的流程ID")
    private Long taskId;
    /**
     * 1未上报，2待审批，3已审批
     */
	@ApiModelProperty("资料流程状态，1未上报，2待审批，3已审批")
    private Integer taskStatus;
    /**
     * 填报人ID及姓名，多人则逗号拼接，ID与姓名间用 - 隔开
     */
	@ApiModelProperty("填报人ID及姓名，多人则逗号拼接，ID与姓名间用 - 隔开")
    private String fileUserIdAndName;
    /**
     * 审批人ID及姓名，多人则逗号拼接，ID与姓名间用 - 隔开
     */
	@ApiModelProperty("审批人ID及姓名，多人则逗号拼接，ID与姓名间用 - 隔开")
    private String auditUserIdAndName;
    /**
     * 上报批次，施工质检共用
     */
	@ApiModelProperty("上报批次，施工质检共用")
    private Integer reportNumber;
    /**
     * 00施工质检未完成，10施工已完成质检未完成，01施工未完成质检已完成，11施工质检已完成
     */
	@ApiModelProperty("00施工质检未完成，10施工已完成质检未完成，01施工未完成质检已完成，11施工质检已完成")
    private String completionStatus;
    /**
     * 数据源类型，1原生，2数字化
     */
    @ApiModelProperty("数据源类型，1原生，2数字化")
    private Integer sourceType;

}
