/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.entity;

import com.baomidou.mybatisplus.annotation.TableName;

import java.io.Serializable;
import java.time.LocalDateTime;

import io.swagger.annotations.ApiModelProperty;
import org.springblade.core.mp.base.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 任务审核主表实体类
 *
 * @author BladeX
 * @since 2022-07-01
 */
@Data
@TableName("u_task")
@EqualsAndHashCode(callSuper = true)
public class Task extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 流程定义主键
     */
    @ApiModelProperty("流程定义主键")
    private String processDefinitionId;

    /**
     * 流程实例主键
     */
    @ApiModelProperty("流程实例主键")
    private String processInstanceId;

    /**
     * 开始时间
     */
    @ApiModelProperty("开始时间")
    private String startTime;

    /**
     * 结束时间
     */
    @ApiModelProperty("结束时间")
    private String endTime;

    /**
     * 任务名称
     */
    @ApiModelProperty("任务名称")
    private String taskName;

    /**
     * 任务内容
     */
    @ApiModelProperty("任务内容")
    private String taskContent;

    /**
     * 第一环节审批人
     */
    @ApiModelProperty("第一环节审批人")
    private String taskUser;

    /**
     * 固定流程ID
     */
    @ApiModelProperty("固定流程ID")
    private Long fixedFlowId;

    /**
     * 数据指向
     */
    @ApiModelProperty("数据指向")
    private Long formDataId;

    /**
     * 上报批次
     */
    @ApiModelProperty("上报批次")
    private Integer batch;

    /**
     * 电签状态，1成功，99失败
     */
    @ApiModelProperty("电签状态，1成功，99失败")
    private String eVisaStatus;

    /**
     * 电签结果内容
     */
    @ApiModelProperty("电签结果内容")
    private String eVisaContent;

    /**
     * 上报人
     */
    @ApiModelProperty("上报人")
    private String reportUser;

    /**
     * 上报人姓名
     */
    @ApiModelProperty("上报人姓名")
    private String reportUserName;

}
