/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.entity;

import com.baomidou.mybatisplus.annotation.TableName;

import java.io.Serializable;
import java.util.Date;

import org.springblade.core.mp.base.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 合同段划分树首件关联表实体类
 *
 * @author BladeX
 * @since 2022-06-16
 */
@Data
@TableName("u_tree_contract_first")
@EqualsAndHashCode(callSuper = true)
public class TreeContractFirst extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 项目ID
     */
    private Long projectId;

    /**
     * 合同段ID
     */
    private Long contractId;

    /**
     * wbs_tree_contract表p_key_id
     */
    private Long wbsNodeId;

    public TreeContractFirst(Long projectId, Long contractId, Long wbsNodeId, Long userId, String deptId){
        this.projectId = projectId;
        this.contractId = contractId;
        this.wbsNodeId = wbsNodeId;
        this.setCreateUser(userId);
        this.setCreateDept(deptId.contains(",") ? Long.parseLong(String.valueOf(deptId).split(",")[0]) : Long.parseLong(deptId));
        this.setCreateTime(new Date());
    }

    public TreeContractFirst(){}

}
