/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.entity;

import com.baomidou.mybatisplus.annotation.TableName;

import java.io.Serializable;

import io.swagger.annotations.ApiModelProperty;
import org.springblade.core.mp.base.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 用户意见表实体类
 *
 * @author BladeX
 * @since 2022-05-25
 */
@Data
@TableName("u_user_opinion")
@EqualsAndHashCode(callSuper = true)
public class UserOpinion extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 项目ID
     */
    @ApiModelProperty(value = "项目ID")
    private Long projectId;
    /**
     * 合同段ID
     */
    @ApiModelProperty(value = "合同段ID")
    private Long contractId;
    /**
     * 内容
     */
    @ApiModelProperty(value = "内容")
    private String opinionContent;
    /**
     * 第几次流程，初始为1，触发“不满意并再次提交解决”时在当前基础上递增
     */
    @ApiModelProperty(value = "第几次流程")
    private Integer number;
	/**
	 * 创建人姓名
	 */
    @ApiModelProperty(value = "创建人姓名")
	private String createUserName;
    /**
     * 问题类型
     */
    @ApiModelProperty(value = "问题类型")
    private String problemType;
    /**
     * 点赞数
     */
    @ApiModelProperty(value = "工单点赞总数")
    private Integer goodNumber;

}
