/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.entity;

import com.baomidou.mybatisplus.annotation.TableName;

import java.io.Serializable;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import org.springblade.core.mp.base.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 用户意见评论表实体类
 *
 * @author BladeX
 * @since 2022-05-25
 */
@Data
@TableName("u_user_opinion_comments")
@EqualsAndHashCode(callSuper = true)
public class UserOpinionComments extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * u_user_opinion表主键
     */
    private Long userOpinionId;
    /**
     * 回复ID，当前表主键，目前只做一级回复，所以当前字段预留
     */
    private Long replyId;
    /**
     * 回复内容
     */
    @ApiModelProperty("回复内容")
    private String replyContent;
    /**
     * 点赞量
     */
    @ApiModelProperty("点赞量")
    private Integer goodCount;
    /**
     * 项目ID，创建人所在项目
     */
    private Long projectId;
    /**
     * 合同段ID，创建人所在合同段
     */
    private Long contractId;


}
