/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.entity;

import com.baomidou.mybatisplus.annotation.TableName;

import java.io.Serializable;
import java.util.Date;

import org.springblade.core.mp.base.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 点赞记录表实体类
 *
 * @author BladeX
 * @since 2022-06-21
 */
@Data
@TableName("u_user_opinion_good")
@EqualsAndHashCode(callSuper = true)
public class UserOpinionGood extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * u_user_opinion id
     */
    private Long userOpinionId;

    public UserOpinionGood(Long userOpinionId, Long userId, Long deptId){
        this.userOpinionId = userOpinionId;
        this.setCreateUser(userId);
        this.setCreateDept(deptId);
        this.setCreateTime(new Date());
    }

    public UserOpinionGood(){}

}
