package org.springblade.business.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.util.Date;

/**
 * 天气台账实体
 */
@Data
@TableName("u_weather_info")
public class WeatherInfo implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id")
    @ApiModelProperty(value = "主键")
    private Long id;

    @NotNull
    @ApiModelProperty(value = "合同段区域ID")
    private String contractAreaId;

    @ApiModelProperty(value = "天气")
    private String weather;

    @ApiModelProperty(value = "平均温度")
    private String airTemp;

    @ApiModelProperty(value = "天气记录日期")
    private Date recordTime;

    @ApiModelProperty(value = "最高温度")
    private String tempHigh;

    @ApiModelProperty(value = "最低温度")
    private String tempLow;

    @ApiModelProperty(value = "风力等级")
    private String windLevel;

    private Long createUser;

    private String createDept;

    private Date createTime;

    private Long updateUser;

    private Date updateTime;

    @ApiModelProperty(value = "状态")
    private Integer status;

    @NotNull
    @TableLogic
    @ApiModelProperty(value = "是否已经删除")
    private Integer isDeleted;

    public WeatherInfo(String contractAreaId, String weather, String airTemp, String tempHigh, String tempLow, String windLevel){
        this.contractAreaId = contractAreaId;
        this.weather = weather;
        this.airTemp = airTemp;
        this.tempHigh = tempHigh;
        this.tempLow = tempLow;
        this.windLevel = windLevel;
    }

    public WeatherInfo(){}

}
