package org.springblade.business.feign;

import org.springblade.common.constant.BusinessConstant;
import org.springblade.core.secure.BladeUser;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

@FeignClient(value =
        BusinessConstant.APPLICATION_WEATHER_NAME
)
public interface InformationQueryClient {

    /**
     * 接口前缀
     */
    String API_PREFIX = "/api/business/informationQuery";

    /**
     * 保存填报时新增或修改填报资料记录表数据
     * @param user 当前操作用户
     * @param wbsId 当前填报节点
     * @param fileName 文件题名
     * @param classify 1施工2质检
     * @param sourceType 1原生2数据化
     * @param dataId 1原生2数据化
     */
    @PostMapping(API_PREFIX + "/saveOrUpdateInformationQueryData")
    void saveOrUpdateInformationQueryData(@RequestBody BladeUser user, @RequestParam Long wbsId, @RequestParam String fileName, @RequestParam Integer classify, @RequestParam Integer sourceType, @RequestParam Long dataId);

}
