package org.springblade.business.feign;

import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.business.entity.AssessmentUser;
import org.springblade.business.vo.AssessmentUserVOS;
import org.springblade.common.constant.BusinessConstant;
import org.springblade.core.tool.api.R;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;
import org.springblade.core.mp.support.Query;

import java.util.List;

@FeignClient(value = BusinessConstant.APPLICATION_WEATHER_NAME)
public interface OpinionUserClient {

    /**
     * 接口前缀
     */
    String API_PREFIX = "/api/business/opinionUser";

    /**
     * 取消考核
     */
    @PostMapping(API_PREFIX + "/cancelAssessment")
    Boolean cancelAssessment(@RequestParam String id);

    /**
     * 获取用户的被考核记录
     */
    @GetMapping(API_PREFIX + "/queryUserAssessmentByUserId")
    List<AssessmentUser> queryUserAssessmentByUserId(@RequestParam String userId);

    /**
     * 获取详情
     */
    @PostMapping(API_PREFIX + "/getById")
    AssessmentUser getById(@RequestParam String id);

    /**
     * 修改考核
     */
    @PostMapping(API_PREFIX + "/updateUserAssessment")
    Boolean updateUserAssessment(@RequestBody AssessmentUser assessmentUser);

    /**
     * 新增考核
     */
    @PostMapping(API_PREFIX + "/saveUserAssessment")
    Boolean saveUserAssessment(@RequestBody AssessmentUser assessmentUser);

    /**
     * 获取考核区列表
     */
    @GetMapping(API_PREFIX + "/queryUserAssessmentPageList")
    List<AssessmentUserVOS> queryUserAssessmentPageList(@RequestBody AssessmentUserVOS vo);

    /**
     * 统计考核区列表
     */
    @GetMapping(API_PREFIX + "/countUserAssessmentPageList")
    Integer countUserAssessmentPageList(@RequestBody AssessmentUserVOS vo);

}
