package org.springblade.business.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;
import java.util.List;

@Data
public class BusinessUserOpinionVO {

    /**
     * 工单ID
     */
    @ApiModelProperty(value = "工单ID")
    private Long userOpinionId;

    /**
     * 提交时间
     */
    @ApiModelProperty(value = "提交时间")
    private Date createTime;

    /**
     * 剩余时间（分钟）
     */
    @ApiModelProperty(value = "剩余时间（分钟）")
    private String timeRemaining;

    /**
     * 最后处理时间
     */
    @ApiModelProperty(value = "最后处理时间")
    private String manageTime;

    /**
     * 项目名称
     */
    @ApiModelProperty(value = "项目名称")
    private String projectName;

    /**
     * 合同段名称
     */
    @ApiModelProperty(value = "合同段名称")
    private String contractName;

    /**
     * 问题类型
     */
    @ApiModelProperty(value = "问题类型")
    private String problemType;

    /**
     * 内容
     */
    @ApiModelProperty(value = "内容")
    private String opinionContent;

    /**
     * 图片路径
     */
    @ApiModelProperty(value = "图片路径")
    private List<String> imageUrl;

    /**
     * 当前用户的处理状态(false为异常或未处理，true为已处理，但不一定是最新的)
     */
    @ApiModelProperty(value = "当前用户的处理状态(false为异常或未处理，true为已处理，但不一定是最新的)")
    private Boolean isCurrent;

    /**
     * 当前用户处理属于第几次流程
     */
    @ApiModelProperty(value = "第几次流程")
    private Integer number;

    /**
     * 当前用户的评价类型，默认null: 1满意，2不满意并再次提交，3不满意并投诉
     */
    @ApiModelProperty(value = "当前用户的评价类型，默认null: 1满意，2不满意并再次提交，3不满意并投诉")
    private Integer evaluation;

    /**
     * 当前工单的最新处理状态(false为异常或未处理，true为已处理，但不一定是最新的)
     */
    @ApiModelProperty(value = "当前工单的最新处理状态(false为异常或未处理，true为已处理，但不一定是最新的)")
    private Boolean newIsCurrent;

    /**
     * 当前工单最新的流程
     */
    @ApiModelProperty(value = "当前工单最新的流程")
    private Integer newNumber;

    /**
     * 当前流程能否被当前登录用户操作
     */
    @ApiModelProperty(value = "当前流程能否被当前登录用户操作")
    private Boolean operation;

    /**
     * 当前环节ID
     */
    @ApiModelProperty(value = "当前环节ID")
    private Long currentLinkId;

    /**
     * 当前环节
     */
    @ApiModelProperty(value = "当前环节")
    private Integer currentLink;

}
