/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.vo;

import io.swagger.annotations.ApiModelProperty;
import org.springblade.business.entity.FirstInformation;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.List;

/**
 * 首件信息记录表视图实体类
 *
 * @author BladeX
 * @since 2022-06-20
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class FirstInformationVO extends FirstInformation {
	private static final long serialVersionUID = 1L;

	/**
	 * 输入框通用查询
	 */
	@ApiModelProperty("输入框通用查询")
	private String queryValue;

	/**
	 * 时间查询
	 */
	@ApiModelProperty("时间查询,间隔用~")
	private String betweenTime;

	private String startTime;

	private String endTime;

	/**
	 * 当前页
	 */
	@ApiModelProperty("当前页")
	private Integer current;

	/**
	 * 当前页显示条数
	 */
	@ApiModelProperty("当前页显示条数")
	private Integer size;

	@ApiModelProperty("节点查询")
	private String wbsNodeIds;

	private List<String> wbsNodeArray;

}
