/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springblade.business.entity.FixedFlow;
import org.springblade.business.entity.FixedFlowLink;
import org.springblade.core.mp.support.Query;
import java.util.ArrayList;
import java.util.List;

/**
 * 视图实体类
 *
 * @author BladeX
 * @since 2022-07-01
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class FixedFlowVO extends FixedFlow {
	private static final long serialVersionUID = 1L;

	@ApiModelProperty("环节处理人姓名及ID，拼接格式为：环节处理人姓名-环节处理人ID(英文逗号)环节处理人姓名-环节处理人ID")
	private String linkUserJoinString;

	@ApiModelProperty("项目ID")
	private Long projectId;

	@ApiModelProperty("合同段ID")
	private Long contractId;

	@ApiModelProperty("环节信息")
	private List<FixedFlowLink> fixedFlowLinkList = new ArrayList<>();

	@ApiModelProperty("当前页")
	private Integer current;

	@ApiModelProperty("当前页总数")
	private Integer size;

	private Query query;

	public Query getQuery(Integer current, Integer size){
		query = new Query();
		query.setCurrent(current);
		query.setSize(size);
		return query;
	}

}
