/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.vo;

import io.swagger.annotations.ApiModelProperty;
import org.springblade.business.entity.ImageClassificationFile;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

/**
 * 视图实体类
 *
 * @author BladeX
 * @since 2022-05-24
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class ImageClassificationFileVO extends ImageClassificationFile {
	private static final long serialVersionUID = 1L;

	/**
	 * 附件
	 */
	private MultipartFile file;

	/**
	 * 是否修改
	 */
	private String update;

	/**
	 * 节点ID集合，多用于点击上级节点时查询其下级节点
	 */
	private List<String> wbsIds;

	@ApiModelProperty("父级节点查询")
	private String wbsIdsStr;

	/**
	 * 共用查询条件
	 */
	@ApiModelProperty("共用查询条件")
	private String queryStr;

	/**
	 * 时间查询(年、年-月、年-月-日)
	 */
	@ApiModelProperty("时间查询(年、年-月、年-月-日)")
	private String queryDate;

	/**
	 * 拍摄时间，字符串
	 */
	@ApiModelProperty("拍摄时间，字符串")
	private String shootingTimeStr;

}
