/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.vo;

import io.swagger.annotations.ApiModelProperty;
import org.springblade.business.entity.InformationQuery;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.List;

/**
 * 视图实体类
 *
 * @author BladeX
 * @since 2022-06-08
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class InformationQueryVO extends InformationQuery {
	private static final long serialVersionUID = 1L;

	@ApiModelProperty("每页条数")
	private int size;

	@ApiModelProperty("当前页")
	private int current;

	private List<String> wbsIds;

	@ApiModelProperty("流程状态，中文")
	private String taskStatusStr;

	@ApiModelProperty("输入框内容查询")
	private String queryValue;

	@ApiModelProperty("时间查询,起止间隔符用~")
	private String betweenTime;

	private String startTime;

	private String endTime;

}
