package org.springblade.business.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
public class NeiYeLedgerVO {

    /**
     * 单位工程
     */
    @ApiModelProperty(value = "单位工程")
    private String unitProject;

    /**
     * 分部工程
     */
    @ApiModelProperty(value = "分部工程")
    private String partProject;

    /**
     * 分项工程
     */
    @ApiModelProperty(value = "分项工程")
    private String subentryProject;

    /**
     * 工序
     */
    @ApiModelProperty(value = "工序")
    private String process;

    //施工台账信息 start ==================================
    /**
     * 施工起止时间
     */
    @ApiModelProperty(value = "施工起止时间")
    private String siteStartToEndTime;

    /**
     * 检测起止时间
     */
    @ApiModelProperty(value = "检测起止时间")
    private String detectionStartToEndTime;
    //施工台账信息 end ==================================

    /**
     * 上报批次
     */
    @ApiModelProperty(value = "上报批次")
    private String reportNumber;

    /**
     * 审批状态
     */
    @ApiModelProperty(value = "审批状态，1未上报，2待审批，3已审批")
    private String taskStatus;

    /**
     * 是否评定
     */
    @ApiModelProperty(value = "是否评定 true为已评定")
    private Boolean isEvaluate;

    /**
     * 是否关联试验
     */
    @ApiModelProperty(value = "是否关联试验 true为已关联")
    private Boolean isExperiment;

    public NeiYeLedgerVO(String... values){
        this.unitProject = values[0];
        this.partProject = values[1];
        this.subentryProject = values[2];
        this.process = values[3];
        this.siteStartToEndTime = values[4];
        this.detectionStartToEndTime = values[5];
        this.taskStatus = values[6];
        this.isEvaluate = Boolean.parseBoolean(values[7]);
        this.isExperiment = Boolean.parseBoolean(values[8]);
    }

    public NeiYeLedgerVO(){}

}
