/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.vo;

import io.swagger.annotations.ApiModelProperty;
import org.springblade.business.entity.UserOpinionFlow;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 用户意见处理流程表视图实体类
 *
 * @author BladeX
 * @since 2022-05-25
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class UserOpinionFlowVO extends UserOpinionFlow {
	private static final long serialVersionUID = 1L;

	@ApiModelProperty(value = "是否执行到当前环节，false(0未执行，1正在执行)，true(2环节结束)")
	private Boolean currentBol;

}
