/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.wrapper;

import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.business.entity.ConstructionLedger;
import org.springblade.business.vo.ConstructionLedgerVO;
import java.util.Objects;

/**
 * 包装类,返回视图层所需的字段
 *
 * @author BladeX
 * @since 2022-05-23
 */
public class ConstructionLedgerWrapper extends BaseEntityWrapper<ConstructionLedger, ConstructionLedgerVO>  {

	public static ConstructionLedgerWrapper build() {
		return new ConstructionLedgerWrapper();
 	}

	@Override
	public ConstructionLedgerVO entityVO(ConstructionLedger constructionLedger) {
		ConstructionLedgerVO constructionLedgerVO = Objects.requireNonNull(BeanUtil.copy(constructionLedger, ConstructionLedgerVO.class));

		//User createUser = UserCache.getUser(constructionLedger.getCreateUser());
		//User updateUser = UserCache.getUser(constructionLedger.getUpdateUser());
		//constructionLedgerVO.setCreateUserName(createUser.getName());
		//constructionLedgerVO.setUpdateUserName(updateUser.getName());

		return constructionLedgerVO;
	}

}
