package org.springblade.manager.dto;


import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springblade.manager.entity.WbsFormElement;
import org.springblade.manager.entity.WbsTree;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.util.List;

/**
 * 表单、元素传输对象实体类
 *
 * @author liuyc
 * @since 2022-04-27
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class FormElementDTO extends WbsTree {
    private static final long serialVersionUID = 1L;
    /**
     * wbs库id
     */
    @ApiModelProperty(value = "wbs库id",required = true)
    private String wbsId;
    /**
     * 租户id
     */
    @ApiModelProperty(value = "租户id",required = true)
    private String tenantId;

    /**
     * 父主键
     */
    @ApiModelProperty(value = "父主键id",required = true)
    private Long parentId;

    /**
     * 部门类型
     */
    @ApiModelProperty(value = "节点类型",required = true)
    private Integer deptCategory;

    /**
     * 部门名
     */
    @ApiModelProperty(value = "节点名称",required = true)
    private String deptName;
    /**
     * 表单类型
     */
    @ApiModelProperty(value = "表单类型",required = true)
    private Integer tableType;

    /**
     * 排序
     */
    @ApiModelProperty(value = "排序")
    private Integer sort;

    /**
     * 元素集合
     */
    @ApiModelProperty(value = "元素集合")
    private List<WbsFormElement> elementList;
}
