package org.springblade.manager.dto;

import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.springblade.manager.entity.WbsTreeContract;


/**
 * 项目分配wbs传输对象实体类
 *
 * @author liuyc
 * @since 2022-05-12
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
public class WbsTreeContractDTO extends WbsTreeContract {
    private static final long serialVersionUID = 1L;

    /**
     * wbsTreeId
     */
    @JsonProperty(value = "wbsTreeIds")
    @ApiModelProperty(name = "wbsTreeIds", value = "字符串拼接wbsTreeIds", required = true)
    private String wbsTreeIds;

    /**
     * 引用类型
     */
    @JsonProperty(value = "referenceType")
    @ApiModelProperty(name = "referenceType", value = "引用类型 : public / private ", required = true)
    private String referenceType;

    /**
     * 引用私有库项目id
     */
    @JsonProperty(value = "referencePrivateWbsProjectId")
    @ApiModelProperty(name = "referencePrivateWbsProjectId", value = "引用的私有库项目id", required = true)
    private String referencePrivateWbsProjectId;

    /**
     * 私有库的根节点primaryKeyId
     */
    @JsonProperty(value = "primaryKeyId")
    @ApiModelProperty(name = "primaryKeyId", value = "私有库的根节点primaryKeyId", required = true)
    private String primaryKeyId;


}
