/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.manager.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springblade.core.mp.base.BaseEntity;

/**
 * 实体类
 *
 * @author liuyc
 * @since 2022-06-29
 */
@Data
@TableName("m_archive_tree")
@EqualsAndHashCode(callSuper = true)
public class ArchiveTree extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 租户Id
     */
    private String tenantId;

    /**
     * 父主键
     */
    private Long parentId;

    /**
     * 祖级列表
     */
    private String ancestors;

    /**
     * 节点名
     */
    private String nodeName;

    /**
     * 节点全称
     */
    private String fullName;

    /**
     * 节点类型
     */
    private Integer nodeType;

    /**
     * 岗位类型
     */
    private Integer postType;

    /**
     * 关联类型
     */
    private Integer associationType;

    /**
     * 内业资料类型
     */
    private String majorDataType;

    /**
     * 显示层级
     */
    private String displayHierarchy;

    /**
     * 是否为存储节点 '0'否 '1'是
     */
    private Integer isStorageNode;

    /**
     * 是否为竣工图 '0'否 '1'是
     */
    private Integer isBuiltDrawing;

    /**
     * 是否为接口节点 '0'否 '1'是
     */
    private Integer isInterfaceNode;

    /**
     * 接口类型
     */
    private Integer interfaceType;

    /**
     * 排序
     */
    private Integer sort;

    /**
     * 备注
     */
    private String remark;

    /**
     * 是否配置到上传文件显示配置树 '0'否 '1'是
     */
    private Integer isUploadFileDisplayConfigurationTree;


}
