/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.manager.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;

import io.swagger.annotations.ApiModelProperty;
import org.springblade.core.mp.base.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 清表基础数据表实体类
 *
 * @author BladeX
 * @since 2022-05-18
 */
@Data
@TableName("m_excel_tab")
@EqualsAndHashCode(callSuper = true)
public class ExcelTab extends BaseEntity {

	private static final long serialVersionUID = 1L;

	/**
	* 父级菜单
	*/

	@ApiModelProperty(value = "父级菜单id")
		private Long parentId;
	/**
	* 文件类型
	*/
	    @ApiModelProperty(value = "文件类型 1 表示祖节点  2 表示为节点信息 3 表示清表")
		private Integer fileType;
	/**
	 * 表类型
	 */
	@ApiModelProperty(value = "表类型")
	private Long tabType;

	/**
	 * 租户ID
	 */
	@ApiModelProperty(value = "租户ID")
	private String tenantId;

	/**
	* 节点名称
	*/
	@ApiModelProperty(value = "节点名称")
		private String name;
	/**
	* 祖级
	*/
	@ApiModelProperty(value = "祖级")
		private String alias;
	/**
	* 文件地址
	*/
	@ApiModelProperty(value = "文件地址")
		private String fileUrl;
	/**
	* 表数量
	*/
	@ApiModelProperty(value = "表数量")
		private Integer tabCout;
	/**
	* 附件拓展名
	*/
	@ApiModelProperty(value = "附件名")
		private String extension;

	/**
	 * html路径
	 */
	@ApiModelProperty(value = "html路径")
	private String htmlUrl;


	/**
	* 附件大小
	*/
	@ApiModelProperty(value = "附件大小")
		private Long attachSize;


}
