/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.manager.entity;

import com.baomidou.mybatisplus.annotation.TableName;

import java.io.Serializable;

import io.swagger.annotations.ApiModelProperty;
import org.springblade.core.mp.base.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 影像分类配置表实体类
 *
 * @author BladeX
 * @since 2022-05-16
 */
@Data
@TableName("m_image_classification_config")
@EqualsAndHashCode(callSuper = true)
public class ImageClassificationConfig extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 分类名称
     */
    @ApiModelProperty(value = "分类名称")
    private String classfName;
    /**
     * 所属项目阶段
     */
    @ApiModelProperty(value = "所属项目阶段")
    private String projectStage;
    /**
     * 所属方
     */
    @ApiModelProperty(value = "所属方")
    private String affiliatedParty;
    /**
     * 文件类型
     */
    @ApiModelProperty(value = "文件类型 1视频文件，2图片文件")
    private Integer fileType;
    /**
     * 存储目录格式
     */
    @ApiModelProperty(value = "存储目录格式 1按部位存储，2按日期存储")
    private Integer storageDirectoryFormat;


}
