package org.springblade.manager.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springblade.core.mp.base.BaseEntity;

import java.io.Serializable;

/**
 * 项目合同人员分配传输对象实体类
 *
 * @author liuyc
 * @since 2022-05-09
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@TableName("m_project_assignment_user")
public class SaveUserInfoByProject extends BaseEntity{
    private static final long serialVersionUID = 1L;

    /**
     * 项目id
     */
    @JsonProperty(value = "projectId")
    @ApiModelProperty(value = "projectId",required = true)
    private String projectId;

    /**
     * 合同id
     */
    @JsonProperty(value = "contractId")
    @ApiModelProperty(value = "contractId",required = true)
    private String contractId;

    /**
     * 角色id
     */
    @JsonProperty(value = "roleId")
    @ApiModelProperty(value = "roleId",required = true)
    private String roleId;

    /**
     * 岗位id
     */
    @JsonProperty(value = "postId")
    @ApiModelProperty(value = "postId",required = true)
    private String postId;

    /**
     * 用户id
     */
    @JsonProperty(value = "userId")
    @ApiModelProperty(value = "userId",required = true)
    private String userId;





}
