/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.manager.entity;

import com.baomidou.mybatisplus.annotation.TableName;

import java.io.Serializable;

import io.swagger.annotations.ApiModelProperty;
import org.springblade.core.mp.base.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 实体类
 *
 * @author BladeX
 * @since 2022-06-28
 */
@Data
@TableName("m_sign_pfx_deputy")
@EqualsAndHashCode(callSuper = true)
public class SignPfxDeputy extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * sign_pfx_file表主键
     */
    private Long signPfxFileId;
    /**
     * 项目ID
     */
    @ApiModelProperty("项目ID")
    private Long projectId;
    /**
     * 项目名称
     */
    @ApiModelProperty("项目名称")
    private String projectName;

    @ApiModelProperty("合同段ID")
    private Long contractId;
    /**
     * 合同段名称
     */
    @ApiModelProperty("合同段名称")
    private String contractName;
    /**
     * 角色ID
     */
    @ApiModelProperty("角色ID")
    private Long roleId;
    /**
     * 角色名称
     */
    @ApiModelProperty("角色名称")
    private String roleName;


}
