package org.springblade.manager.entity;


import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.springblade.core.mp.base.BaseEntity;


/**
 * wbs合同段树关系实体类
 *
 * @author liuyc
 * @since 2022-05-12
 */
@Data
@TableName("m_wbs_tree_contract")
@EqualsAndHashCode(callSuper = true)
@NoArgsConstructor
@AllArgsConstructor
public class WbsTreeContract extends BaseEntity {
    private static final long serialVersionUID = 1L;

    /**
     * 主键id
     */
    private Long pKeyId;

    /**
     * wbsId
     */
    @ApiModelProperty(name = "wbsId", value = "wbsId", required = true)
    private String wbsId;

    /**
     * wbsType
     */
    @ApiModelProperty(name = "wbsType", value = "wbsType")
    private Integer wbsType;

    /**
     * 项目Id
     */
    @JsonProperty(value = "projectId")
    @ApiModelProperty(name = "projectId", value = "项目Id", required = true)
    private String projectId;

    /**
     * 合同Id
     */
    @JsonProperty(value = "contractId")
    @ApiModelProperty(name = "contractId", value = "合同Id", required = true)
    private String contractId;

    /**
     * 合同段类型
     */
    @ApiModelProperty(name = "contractType", value = "合同段类型")
    private Integer contractType;

    /**
     * 合同段关联id（监理、业主合同关联施工合同id）
     */
    @ApiModelProperty(name = "contractIdRelation", value = "合同段关联id（监理、业主合同关联施工合同id）")
    private String contractIdRelation;

    /**
     * 租户id
     */
    @ApiModelProperty(value = "租户id")
    private String tenantId;

    /**
     * 父主键
     */
    @ApiModelProperty(value = "父主键id")
    private Long parentId;

    /**
     * 部门类型
     */
    @ApiModelProperty(value = "节点类型")
    private Integer deptCategory;

    /**
     * '1'节点 '2'表单
     */
    @ApiModelProperty(value = "'1'节点 '2'表单")
    private Integer type;

    /**
     * 部门名
     */
    @ApiModelProperty(value = "节点名称")
    private String deptName;
    /**
     * 部门全称
     */
    @ApiModelProperty(value = "节点全称")
    private String fullName;

    /**
     * 表单类型
     */
    @ApiModelProperty(value = "表单类型")
    private Integer tableType;

    /**
     * 排序
     */
    @ApiModelProperty(value = "排序")
    private Integer sort;

    /**
     * 祖级列表
     */
    @ApiModelProperty(value = "祖级id列表")
    private String ancestors;

    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String remark;

    /**
     * 唯一编号
     */
    @ApiModelProperty(value = "唯一编号")
    private String uniqueCode;

    /**
     * 划分编号
     */
    @ApiModelProperty(value = "划分编号")
    private String partitionCode;

    /**
     * 是否是实验节点 '0'否 '1'是
     */
    @ApiModelProperty(value = "实验节点")
    private Integer isExpernode;

    /**
     * 是否有混泥土 '0'否 '1'是
     */
    @ApiModelProperty(value = "混泥土")
    private Integer isConcrete;

    /**
     * 表单所属方
     */
    @ApiModelProperty(value = "表单所属方")
    private String tableOwner;

    /**
     * 内业资料类型
     */
    @ApiModelProperty(value = "内业资料类型")
    private Integer majorDataType;

    /**
     * 初始化实体表名
     */
    @ApiModelProperty(value = "初始化实体表名")
    private String initTableName;


    /**
     * 是否关联清表 '0'否 '1'是
     */
    @ApiModelProperty(value = "是否关联清表 '0'否 '1'是")
    private Integer isLinkTable;


}
