package org.springblade.manager.feign;

import org.springblade.manager.entity.ImageClassificationConfig;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

import static org.springblade.core.launch.constant.AppConstant.APPLICATION_NAME_PREFIX;

@FeignClient(value = APPLICATION_NAME_PREFIX +  "manager")
public interface ImageClassificationConfigClient {

    /**
     * 接口前缀
     */
    String API_PREFIX = "/api/manager/imageClassificationConfig";

    /**
     * 获取系统定义的所有有效分类
     * @return 结果集
     */
    @GetMapping(API_PREFIX + "/queryClassificationConfigList")
    List<ImageClassificationConfig> queryClassificationConfigList();

    /**
     * 根据ID集获取分类
     * @param ids ID集合
     * @return 结果集
     */
    @GetMapping(API_PREFIX + "/queryClassificationConfigListByIds")
    List<ImageClassificationConfig> queryClassificationConfigListByIds(@RequestParam List<Long> ids);

}
