package org.springblade.manager.feign;

import org.springblade.manager.entity.ProjectInfo;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

import static org.springblade.core.launch.constant.AppConstant.APPLICATION_NAME_PREFIX;

@FeignClient(value = APPLICATION_NAME_PREFIX +  "manager")
public interface ProjectClient {

    /**
     * 接口前缀
     */
    String API_PREFIX = "/api/manager/project";

    /**
     * 根据项目ID获取合同段
     * @return 结果集
     */
    @GetMapping(API_PREFIX + "/queryProjectList")
    List<ProjectInfo> queryProjectList(@RequestParam List<String> projectIds);

}
