package org.springblade.manager.feign;

import org.springblade.manager.entity.ProjectContractArea;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

import static org.springblade.core.launch.constant.AppConstant.APPLICATION_NAME_PREFIX;

@FeignClient(value = APPLICATION_NAME_PREFIX +  "manager")
public interface ProjectContractAreaClient {

    /**
     * 接口前缀
     */
    String API_PREFIX = "/api/manager/projectContractArea";

    /**
     * 根据合同段获取
     * @param contractId 合同段ID
     * @return 结果
     */
    @GetMapping(API_PREFIX + "/queryContractAreaByContractId")
    ProjectContractArea queryContractAreaByContractId(@RequestParam String contractId);

    @GetMapping(API_PREFIX + "/queryAllContractArea")
    List<ProjectContractArea> queryAllContractArea();

}
