package org.springblade.manager.feign;

import org.springblade.manager.entity.WbsTreePrivate;
import org.springblade.manager.vo.WbsTreePrivateVO;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

import static org.springblade.core.launch.constant.AppConstant.APPLICATION_NAME_PREFIX;

@FeignClient(value = APPLICATION_NAME_PREFIX +  "manager")
public interface WbsTreePrivateClient {

    /**
     * 接口前缀
     */
    String API_PREFIX = "/api/manager/WbsTreePrivate";

    @PostMapping(API_PREFIX + "/queryPeersNodeByProjectIdAndId")
    WbsTreePrivate queryPeersNodeByProjectIdAndId(@RequestParam String projectId, @RequestParam Long id);

    @PostMapping(API_PREFIX + "/queryWbsTreePrivateByProjectIdAndId")
    List<WbsTreePrivateVO> queryWbsTreePrivateByProjectIdAndId(@RequestParam String projectId, @RequestParam Long id);

}
