/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.manager.vo;

import org.springblade.manager.entity.ContractInfo;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.List;

/**
 * 合同段信息表视图实体类
 *
 * @author liuyc
 * @since 2022-04-14
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class ContractInfoVO extends ContractInfo {
    private static final long serialVersionUID = 1L;

    /**
     * 项目名称
     */
    private String projectName;

    /**
     * 合同段名称，用于同一返回格式
     */
    private String name;

    /**
     * 监理、业主分配当前项目下的施工Wbs树根节点idList
     */
    private List<WbsTreeContractVO3> idList;

}
