/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.manager.vo;

import io.swagger.annotations.ApiModelProperty;
import org.springblade.manager.entity.ImageClassificationConfig;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 影像分类配置表视图实体类
 *
 * @author BladeX
 * @since 2022-05-16
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class ImageClassificationConfigVO extends ImageClassificationConfig {
	private static final long serialVersionUID = 1L;

	/**
	 * image_classification_show表 is_show
	 */
	@ApiModelProperty(value = "是否显示 true为显示")
	private Boolean isShow;

	/**
	 * image_classification_show表 ID
	 */
	@ApiModelProperty(value = "显示控制表主键，可为空，若有值则修改数据时必传")
	private Long showId;

	@ApiModelProperty(value = "当前类型下文件数量")
	private Integer count;

}
