package org.springblade.manager.vo;

import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springblade.core.mp.base.BaseEntity;

import java.io.Serializable;

/**
 * 项目合同人员分配视图层
 *
 * @author liuyc
 * @since 2022-06-07
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class SaveUserInfoByProjectVO extends BaseEntity implements Serializable {
    private static final long serialVersionUID = 1L;

    /**
     * 项目id
     */
    @JsonProperty(value = "projectName")
    private String projectName;

    /**
     * 合同id
     */
    @JsonProperty(value = "contractName")
    private String contractName;

    /**
     * 岗位名字
     */
    @JsonProperty(value = "postName")
    private String postName;

    /**
     * 岗位类型
     */
    @JsonProperty(value = "postType")
    private String postType;


}
