/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.manager.vo;

import io.swagger.annotations.ApiModelProperty;
import org.springblade.manager.entity.SignPfxDeputy;
import org.springblade.manager.entity.SignPfxFile;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.ArrayList;
import java.util.List;

/**
 * 个人/企业证书信息表视图实体类
 *
 * @author BladeX
 * @since 2022-06-24
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class SignPfxFileVO extends SignPfxFile {
	private static final long serialVersionUID = 1L;

	@ApiModelProperty("当前页")
	private Integer current;

	@ApiModelProperty("当前页总数")
	private Integer size;

	@ApiModelProperty("转义后证书类型")
	private String certificateTypeValue;

	@ApiModelProperty("是否注册，true为已注册")
	private Boolean isRegisterBoolean;

	@ApiModelProperty("项目合同段信息")
	private List<SignPfxDeputy> signPfxDeputieList;

}
