package org.springblade.manager.vo;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import org.springblade.core.tool.node.BaseNode;
import org.springblade.core.tool.node.TreeNode;


/**
 * 重写了TreeNode实体，增加了字段
 */
public class TreeNodeVO2 extends BaseNode<TreeNode> {
    private static final long serialVersionUID = 1L;
    private String title;
    @JsonSerialize(
            using = ToStringSerializer.class
    )
    private Long key;
    @JsonSerialize(
            using = ToStringSerializer.class
    )
    private Long value;

    private String tenantId;

    private String ancestors;

    /**
     * 内业资料类型(用于显示控制)
     */
    private String majorDataType;

    /**
     * 显示层级(用于显示控制)
     */
    private String displayHierarchy;



    public TreeNodeVO2() {
    }

    public String getMajorDataType() {
        return majorDataType;
    }

    public void setMajorDataType(String majorDataType) {
        this.majorDataType = majorDataType;
    }

    public String getDisplayHierarchy() {
        return displayHierarchy;
    }

    public void setDisplayHierarchy(String displayHierarchy) {
        this.displayHierarchy = displayHierarchy;
    }

    public String getAncestors() {
        return ancestors;
    }

    public void setAncestors(String ancestors) {
        this.ancestors = ancestors;
    }


    public String getTenantId() {
        return tenantId;
    }

    public void setTenantId(String tenantId) {
        this.tenantId = tenantId;
    }


    public String getTitle() {
        return this.title;
    }

    public Long getKey() {
        return this.key;
    }

    public Long getValue() {
        return this.value;
    }

    public void setTitle(final String title) {
        this.title = title;
    }

    public void setKey(final Long key) {
        this.key = key;
    }

    public void setValue(final Long value) {
        this.value = value;
    }

    public String toString() {
        return "TreeNode(tenantId=" + this.getTenantId()
                + ",ancestors" + this.getAncestors()
                + ",majorDataType" + this.getMajorDataType()
                + ",displayHierarchy" + this.getDisplayHierarchy()
                + ", title=" + this.getTitle() + ", key=" + this.getKey() + ", value=" + this.getValue() + ")";
    }

    public boolean equals(final Object o) {
        if (o == this) {
            return true;
        } else if (!(o instanceof TreeNode)) {
            return false;
        } else {
            TreeNodeVO2 other = (TreeNodeVO2) o;
            if (!other.canEqual(this)) {
                return false;
            } else {
                label47:
                {
                    Object this$key = this.getKey();
                    Object other$key = other.getKey();
                    if (this$key == null) {
                        if (other$key == null) {
                            break label47;
                        }
                    } else if (this$key.equals(other$key)) {
                        break label47;
                    }

                    return false;
                }

                Object this$value = this.getValue();
                Object other$value = other.getValue();
                if (this$value == null) {
                    if (other$value != null) {
                        return false;
                    }
                } else if (!this$value.equals(other$value)) {
                    return false;
                }

                Object this$title = this.getTitle();
                Object other$title = other.getTitle();
                if (this$title == null) {
                    if (other$title != null) {
                        return false;
                    }
                } else if (!this$title.equals(other$title)) {
                    return false;
                }

                return true;
            }
        }
    }

    protected boolean canEqual(final Object other) {
        return other instanceof TreeNode;
    }

    public int hashCode() {
        boolean PRIME = true;
        int result = 1;
        Object $key = this.getKey();
        result = result * 59 + ($key == null ? 43 : $key.hashCode());
        Object $value = this.getValue();
        result = result * 59 + ($value == null ? 43 : $value.hashCode());
        Object $title = this.getTitle();
        result = result * 59 + ($title == null ? 43 : $title.hashCode());
        return result;
    }
}
