/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.manager.vo;


import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import java.util.List;

/**
 * 视图实体类
 *
 * @author Chill
 */
@Data
@ApiModel(value = "WbsExclTabParmVO对象", description = "WbsExclTabParmVO对象")
public class WbsExclTabParmVO  {

	private static final long serialVersionUID = 1L;

	/**
	 * 当前节点di
	 */
	@JsonSerialize(using = ToStringSerializer.class)
	@ApiModelProperty(value = "node父节点Id")
	private Long id;

	/**
	 * 父节点ID
	 */
	@JsonSerialize(using = ToStringSerializer.class)
	@ApiModelProperty(value = "node父节点Id")
	private Long parentId;

	/**
	 * 节点名称
	 */
	@ApiModelProperty(value = "节点名称")
	private String nodeName;

	/**
	 * 清表类型
	 */
	@ApiModelProperty(value = "清表类型")
	private Long tabType;

	/**
	 * 关联信息
	 */
	@ApiModelProperty(value = "关联信息")
	private List<ExcelTabWbsTypeVO> linkDataInfo;


}
