package org.springblade.manager.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;

/**
 * wbs动态库节点表单视图实体类
 *
 * @author liuyc
 * @since 2022-04-25
 */
@Data
public class WbsNodeTableVO implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * pKeyId 主键id
     */
    private Long pKeyId;

    /**
     * id
     */
    private String id;

    /**
     * 表单名称
     */
    private String tableName;

    /**
     * 排序
     */
    private Integer sort;

    /**
     * 表单类型
     */
    private String tableType;

    /**
     * 元素总数
     */
    private Integer elementTotal;

    /**
     * 是否创建表
     */
    private Boolean isCreateTable = true;

    /**
     * 所属方
     */
    private String tableOwner;

    /**
     * 是否关联清表 '1'否 '2'是
     */
    @ApiModelProperty(value = "是否关联清表 '1'否 '2'是")
    private Integer isLinkTable;

    /**
     * excelId
     */
    @ApiModelProperty(value = "清表Id")
    private Long excelId;

    /**
     * 初始化实体表名
     */
    private String initTableName;

}
