package org.springblade.manager.vo;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import org.springblade.core.tool.node.INode;
import org.springblade.manager.entity.WbsTreeContract;

import java.util.ArrayList;
import java.util.List;

public class WbsTreeContractTreeVO2 extends WbsTreeContract implements INode<WbsTreeContractTreeVO2> {
    private static final long serialVersionUID = 1L;

    /**
     * 主键Id
     */
    private Long pKeyId;

    /**
     * 主键ID
     */
    @JsonSerialize(using = ToStringSerializer.class)
    private Long id;

    /**
     * 父节点ID
     */
    @JsonSerialize(using = ToStringSerializer.class)
    private Long parentId;

    /**
     * 子孙节点
     */
    @JsonInclude(JsonInclude.Include.NON_EMPTY)
    private List<WbsTreeContractTreeVO2> children;

    /**
     * 是否有子孙节点
     */
    @JsonInclude(JsonInclude.Include.NON_EMPTY)
    private Boolean hasChildren;

    @Override
    public List<WbsTreeContractTreeVO2> getChildren() {
        if (this.children == null) {
            this.children = new ArrayList<>();
        }
        return this.children;
    }
}
