/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.controller;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.business.entity.Task;
import org.springblade.business.vo.TaskVO;
import org.springblade.business.service.ITaskService;
import org.springblade.core.boot.ctrl.BladeController;

/**
 * 任务审核主表 控制器
 *
 * @author BladeX
 * @since 2022-07-01
 */
@RestController
@AllArgsConstructor
@RequestMapping("/task")
@Api(value = "任务审核主表", tags = "任务审核主表接口")
public class TaskController extends BladeController {

	private final ITaskService taskService;

	/**
	 * 上报
	 */
	@PostMapping("start-approval")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "上报", notes = "taskVO对象")
	public R startApproval(@RequestBody TaskVO taskVO){
		return R.data(this.taskService.startApproval(taskVO));
	}
	
}
