/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.mapper;

import org.springblade.business.entity.ConstructionLedger;
import org.springblade.business.vo.ConstructionLedgerVO;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import java.util.List;
import org.apache.ibatis.annotations.Param;

/**
 *  Mapper 接口
 *
 * @author BladeX
 * @since 2022-05-23
 */
public interface ConstructionLedgerMapper extends BaseMapper<ConstructionLedger> {

	/**
	 * 自定义分页
	 *
	 * @param current 分页信息
	 * @param size 分页信息
	 * @param constructionLedger 参数
	 * @return 结果
	 */
	List<ConstructionLedger> selectConstructionLedgerPage(@Param("current") long current,@Param("size") long size, @Param("param") ConstructionLedgerVO constructionLedger);

	/**
	 * 根据ID修改部分信息
	 * @param constructionLedger 参数
	 * @return 修改结果
	 */
	Integer updateByIdNotAll(@Param("param") ConstructionLedger constructionLedger);

}
