/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.mapper;

import org.apache.ibatis.annotations.Param;
import org.springblade.business.entity.FirstInformation;
import org.springblade.business.vo.FirstInformationVO;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import java.util.List;

/**
 * 首件信息记录表 Mapper 接口
 *
 * @author BladeX
 * @since 2022-06-20
 */
public interface FirstInformationMapper extends BaseMapper<FirstInformation> {

	Integer countFirstInformation(@Param("vo")FirstInformationVO vo);

	/**
	 * 自定义分页
	 */
	List<FirstInformationVO> selectFirstInformationPage(@Param("current")Long current, @Param("size")Long size, @Param("vo")FirstInformationVO vo);

}
