/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.mapper;

import org.apache.ibatis.annotations.Param;
import org.springblade.business.entity.UserOpinionComments;
import org.springblade.business.vo.UserOpinionCommentsVO;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import java.util.List;

/**
 * 用户意见评论表 Mapper 接口
 *
 * @author BladeX
 * @since 2022-05-25
 */
public interface UserOpinionCommentsMapper extends BaseMapper<UserOpinionComments> {

	/**
	 * 获取当前工单下的所有评论
	 * @param userOpinionId 工单ID
	 * @return 结果集
	 */
	List<UserOpinionComments> queryUserOpinionCommentsByUserOpinionId(@Param("key")String userOpinionId);

	/**
	 * 统计点赞数
	 */
	Integer countGoodByUserOpinionKey(@Param("key") Long userOpinionKey);

	/**
	 * 统计评论数
	 */
	Integer countCommentsByUserOpinionKey(@Param("key") Long userOpinionKey);

	/**
	 * 自定义分页
	 */
	List<UserOpinionCommentsVO> selectUserOpinionCommentsPage(IPage page, UserOpinionCommentsVO userOpinionComments);

}
