/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.mapper;

import org.apache.ibatis.annotations.Param;
import org.springblade.business.entity.UserOpinion;
import org.springblade.business.vo.BusinessUserOpinionVO;
import org.springblade.business.vo.UserOpinionVO;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import java.util.List;

/**
 * 用户意见表 Mapper 接口
 *
 * @author BladeX
 * @since 2022-05-25
 */
public interface UserOpinionMapper extends BaseMapper<UserOpinion> {

	List<BusinessUserOpinionVO> queryManageUserOpinionList(@Param("currentUser") String currentUser);

	List<UserOpinion> queryCurrentUserOpinionList(@Param("userId")Long userId);

	/**
	 * 自定义分页
	 */
	List<UserOpinion> selectUserOpinionPage(@Param("current")Long current, @Param("size")Long size, @Param("param") UserOpinionVO userOpinion, @Param("currentUser") String currentUser);

}
