/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.service;

import org.springblade.business.entity.ContractLog;
import org.springblade.business.vo.ContractLogVO;
import org.springblade.business.vo.FileUserVO;
import org.springblade.core.mp.base.BaseService;
import com.baomidou.mybatisplus.core.metadata.IPage;

import java.util.List;

/**
 * 日志通用表 服务类
 *
 * @author BladeX
 * @since 2022-06-15
 */
public interface IContractLogService extends BaseService<ContractLog> {

	List<FileUserVO> queryFillUser(ContractLogVO logVO);

	/**
	 * 施工日志分页
	 * @param logVO 查询条件
	 * @return 结果
	 */
	IPage<ContractLogVO> constructionLogPage(ContractLogVO logVO);

}
