/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.service;

import org.springblade.business.entity.ContractTreeDrawings;
import org.springblade.business.vo.ContractTreeDrawingsVO;
import org.springblade.core.mp.base.BaseService;
import com.baomidou.mybatisplus.core.metadata.IPage;

/**
 *  服务类
 *
 * @author BladeX
 * @since 2022-06-14
 */
public interface IContractTreeDrawingsService extends BaseService<ContractTreeDrawings> {

	/**
	 * 根据节点ID获取其上传的图纸
	 * @param primaryKeyId 节点ID
	 * @return 结果
	 */
	ContractTreeDrawings queryCurrentNodeDrawings(String primaryKeyId);

	/**
	 * 自定义分页
	 *
	 */
	IPage<ContractTreeDrawingsVO> selectContractTreeDrawingsPage(IPage<ContractTreeDrawingsVO> page, ContractTreeDrawingsVO contractTreeDrawings);

}
