/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.service;

import org.springblade.business.entity.FirstInformation;
import org.springblade.business.vo.FirstInformationVO;
import org.springblade.core.mp.base.BaseService;
import com.baomidou.mybatisplus.core.metadata.IPage;

/**
 * 首件信息记录表 服务类
 *
 * @author BladeX
 * @since 2022-06-20
 */
public interface IFirstInformationService extends BaseService<FirstInformation> {

	/**
	 * 修改首件记录表信息
	 * @param id 主键
	 * @param fileName 文件名称
	 * @param reportNumber 上报批次
	 * @param status 流程状态
	 * @return 修改结果
	 */
	Boolean updateFirstInformation(Long id, String fileName, Integer reportNumber, Integer status);

	/**
	 * 保存首件记录表信息
	 * @param wbsNodeId 当前资料所在节点ID
	 * @param fileName 文件名称
	 * @param dataId 数据ID
	 * @return 保存后数据的ID
	 */
	Long saveFirstInformation(Long wbsNodeId, String fileName, Long dataId);

	/**
	 * 自定义分页
	 */
	IPage<FirstInformationVO> selectFirstInformationPage(IPage<FirstInformationVO> page, FirstInformationVO vo);

}
