package org.springblade.business.service;

import org.springblade.business.entity.ImageClassificationFile;
import org.springblade.business.vo.ImageClassificationFileVO;
import org.springblade.business.vo.TreeVo;
import org.springblade.core.mp.base.BaseService;
import com.baomidou.mybatisplus.core.metadata.IPage;
import java.util.List;

/**
 *  服务类
 *
 * @author BladeX
 * @since 2022-05-24
 */
public interface IImageClassificationFileService extends BaseService<ImageClassificationFile> {

	/**
	 * 获取当前分类、项目、合同段下的所有文件数量
	 * @param projectId 项目ID
	 * @param contractId 合同段ID
	 * @param classifyId 分类ID
	 * @return 结果
	 */
	Integer queryCurrentClassifyAllFileCount(String projectId, String contractId, Long classifyId);

	/**
	 * 获取当前分类下当前项目的拍摄时间
	 * @param classifyId 分类ID
	 * @param projectId 项目ID
	 * @return 拍摄时间集合
	 */
	List<TreeVo> getYearDateTree(String classifyId, String projectId, String contractId);

	/**
	 * 自定义分页
	 *
	 * @param page 分页信息
	 * @param imageClassificationFile 查询条件
	 * @return 列表集合
	 */
	IPage<ImageClassificationFileVO> selectImageClassificationFilePage(IPage<ImageClassificationFileVO> page, ImageClassificationFileVO imageClassificationFile);

}
