/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.service;

import org.springblade.business.entity.UserOpinionFile;
import org.springblade.business.vo.UserOpinionFileVO;
import org.springblade.core.mp.base.BaseService;
import com.baomidou.mybatisplus.core.metadata.IPage;

import java.util.List;

/**
 * 用户意见附件表 服务类
 *
 * @author BladeX
 * @since 2022-05-25
 */
public interface IUserOpinionFileService extends BaseService<UserOpinionFile> {

	List<UserOpinionFile> selectUserOpinionFileByUserOpinionKeys(List<Long> userOpinionKeys);

	/**
	 * 获取具体工单相关附件
	 * @param userOpinionKey 主表u_user_opinion主键
	 * @return 结果
	 */
	List<UserOpinionFile> selectUserOpinionFileByUserOpinionKey(Long userOpinionKey);

	/**
	 * 自定义分页
	 */
	IPage<UserOpinionFileVO> selectUserOpinionFilePage(IPage<UserOpinionFileVO> page, UserOpinionFileVO userOpinionFile);

}
