/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.service;

import org.springblade.business.entity.UserOpinionFlow;
import org.springblade.business.vo.AssessmentUserVOS;
import org.springblade.business.vo.UserOpinionFlowVO;
import org.springblade.core.mp.base.BaseService;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.core.tool.api.R;
import org.springblade.core.mp.support.Query;
import java.util.List;

/**
 * 用户意见处理流程表 服务类
 *
 * @author BladeX
 * @since 2022-05-25
 */
public interface IUserOpinionFlowService extends BaseService<UserOpinionFlow> {

	Integer countUserAssessmentPageList(AssessmentUserVOS vo);

	List<AssessmentUserVOS> queryUserAssessmentPage(AssessmentUserVOS vo);

	/**
	 * 获取前一个流程的维护人员
	 * @param number 流程次数
	 * @param userOpinionId
	 * @return
	 */
	UserOpinionFlow queryLeftFlowManageUser(Integer number, String userOpinionId);

	/**
	 * 获取当前工单的最新流程
	 * @param userOpinionId 当前工单ID
	 * @return 最新流程集合
	 */
	List<UserOpinionFlowVO> queryCurrentUserOpinionFlowByUserOpinionId(String userOpinionId, Integer number);

	Integer selectIsSolveByUserOpinionKey(Long userOpinionKey);

}
