/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.service.impl;

import org.springblade.business.entity.FixedFlowLink;
import org.springblade.business.vo.FixedFlowLinkVO;
import org.springblade.business.mapper.FixedFlowLinkMapper;
import org.springblade.business.service.IFixedFlowLinkService;
import org.springblade.core.mp.base.BaseServiceImpl;
import org.springblade.core.tool.utils.Func;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;

import java.util.List;

/**
 *  服务实现类
 *
 * @author BladeX
 * @since 2022-07-01
 */
@Service
public class FixedFlowLinkServiceImpl extends BaseServiceImpl<FixedFlowLinkMapper, FixedFlowLink> implements IFixedFlowLinkService {

	@Override
	public void deletedByFixedFlowId(String fixedFlowIds) {
		this.baseMapper.deletedByFixedFlowId(Func.toLongList(fixedFlowIds));
	}

	@Override
	public List<FixedFlowLink> selectFixedFlowLink(String fixedFlowId) {
		return this.baseMapper.selectFixedFlowLink(fixedFlowId);
	}

}
