/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.service.impl;

import org.apache.commons.lang.time.DateUtils;
import org.springblade.business.entity.Task;
import org.springblade.business.mapper.TaskMapper;
import org.springblade.business.service.ITaskService;
import org.springblade.business.vo.TaskVO;
import org.springblade.core.mp.base.BaseServiceImpl;
import org.springblade.core.tool.utils.DateUtil;
import org.springblade.core.tool.utils.Func;
import org.springblade.flow.core.constant.ProcessConstant;
import org.springblade.flow.core.utils.FlowUtil;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;

import java.util.Date;

/**
 * 任务审核主表 服务实现类
 *
 * @author BladeX
 * @since 2022-07-01
 */
@Service
public class TaskServiceImpl extends BaseServiceImpl<TaskMapper, Task> implements ITaskService {

    @Override
    public Boolean startApproval(TaskVO vo) {
        //获取业务表
        String businessTable = FlowUtil.getBusinessTable(ProcessConstant.EXAMINATION_AND_APPROVAL);
        if(Func.isEmpty(vo.getId())){
            //bean Copy
            Task task = new Task();
            BeanUtils.copyProperties(vo, task);
            //设置开始/结束时间
            Date nowTime = new Date();
            task.setStartTime(DateUtil.format(nowTime, "yyyy-MM-dd"));
            task.setEndTime(DateUtil.format(DateUtils.addDays(nowTime, vo.getRestrictDay()), "yyyy-MM-dd"));


        }
        return null;
    }
}
