/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.business.service.impl;

import org.springblade.business.entity.UserOpinionFile;
import org.springblade.business.vo.UserOpinionFileVO;
import org.springblade.business.mapper.UserOpinionFileMapper;
import org.springblade.business.service.IUserOpinionFileService;
import org.springblade.core.mp.base.BaseServiceImpl;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 用户意见附件表 服务实现类
 *
 * @author BladeX
 * @since 2022-05-25
 */
@Service
public class UserOpinionFileServiceImpl extends BaseServiceImpl<UserOpinionFileMapper, UserOpinionFile> implements IUserOpinionFileService {

	@Override
	public List<UserOpinionFile> selectUserOpinionFileByUserOpinionKeys(List<Long> userOpinionKeys) {
		return this.baseMapper.selectUserOpinionFileByUserOpinionKeys(userOpinionKeys);
	}

	@Override
	public List<UserOpinionFile> selectUserOpinionFileByUserOpinionKey(Long userOpinionKey) {
		Map<String,Object> queryMap = new HashMap<>();
		queryMap.put("user_opinion_id", userOpinionKey);
		return this.baseMapper.selectByMap(queryMap);
	}

	@Override
	public IPage<UserOpinionFileVO> selectUserOpinionFilePage(IPage<UserOpinionFileVO> page, UserOpinionFileVO userOpinionFile) {
		return page.setRecords(this.baseMapper.selectUserOpinionFilePage(page, userOpinionFile));
	}

}
