/*
 Navicat Premium Data Transfer

 Source Server         : localhost
 Source Server Type    : MySQL
 Source Server Version : 50651
 Source Host           : localhost:3306
 Source Schema         : bladex

 Target Server Type    : MySQL
 Target Server Version : 50651
 File Encoding         : 65001

 Date: 24/05/2022 18:08:36
*/

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for u_image_classification_file
-- ----------------------------
DROP TABLE IF EXISTS `u_image_classification_file`;
CREATE TABLE `u_image_classification_file`  (
  `id` bigint(64) NOT NULL COMMENT '主键',
  `classify_id` bigint(64) NOT NULL COMMENT '分类ID，m_image_classification_config表主键',
  `project_id` bigint(64) NOT NULL COMMENT '项目ID',
  `contract_id` bigint(64) NULL DEFAULT NULL COMMENT '合同段ID，预留字段',
  `wbs_id` bigint(64) NULL DEFAULT NULL COMMENT '工程节点ID，可为空',
  `title` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '题名',
  `type` int(10) NULL DEFAULT NULL COMMENT '文件类型，视频格式1，图片格式2',
  `image_url` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '文件所在路径',
  `file_size` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '文件大小',
  `file_name` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '文件名称',
  `shooting_user` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '拍摄者',
  `shooting_time` datetime NULL DEFAULT NULL COMMENT '拍摄时间',
  `photo_code` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '照片号，视频格式不填',
  `film_code` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '底片号，视频格式不填',
  `see_also_code` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '参见号，视频格式不填',
  `text_content` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL COMMENT '文字说明',
  `create_user` bigint(64) NOT NULL COMMENT '创建人',
  `create_dept` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '创建人所在部门',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_user` bigint(64) NULL DEFAULT NULL COMMENT '修改人',
  `update_time` datetime NULL DEFAULT NULL COMMENT '修改时间',
  `status` int(10) NULL DEFAULT NULL COMMENT '状态',
  `is_deleted` int(10) NULL DEFAULT NULL COMMENT '是否已删除',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = Compact;

-- ----------------------------
-- Records of u_image_classification_file
-- ----------------------------
INSERT INTO `u_image_classification_file` VALUES (123456789, 987654321, 123, 456, 789, '哇哈哈哈', 2, NULL, NULL, NULL, NULL, '2022-05-24 15:21:25', NULL, NULL, NULL, NULL, 123322154345, '21354345345', '2022-05-24 15:12:10', NULL, NULL, 0, 0);
INSERT INTO `u_image_classification_file` VALUES (1234567891, 987654321, 123, 456, 789, '哇哈哈哈1', 2, NULL, NULL, NULL, NULL, '2022-05-25 15:21:25', NULL, NULL, NULL, NULL, 123322154345, '21354345345', '2022-05-25 15:12:10', NULL, NULL, 0, 0);
INSERT INTO `u_image_classification_file` VALUES (1234567892, 987654321, 123, 456, 789, '哇哈哈哈2', 2, NULL, NULL, NULL, NULL, '2022-05-26 15:21:25', NULL, NULL, NULL, NULL, 123322154345, '21354345345', '2022-05-26 15:12:10', NULL, NULL, 0, 0);
INSERT INTO `u_image_classification_file` VALUES (1234567893, 987654321, 123, 456, 789, '哇哈哈哈3', 2, NULL, NULL, NULL, NULL, '2022-05-27 15:21:25', NULL, NULL, NULL, NULL, 123322154345, '21354345345', '2022-05-27 15:12:10', NULL, NULL, 0, 0);
INSERT INTO `u_image_classification_file` VALUES (1234567894, 987654321, 123, 456, 789, '哇哈哈哈4', 2, NULL, NULL, NULL, NULL, '2022-05-28 15:21:25', NULL, NULL, NULL, NULL, 123322154345, '21354345345', '2022-05-28 15:12:10', NULL, NULL, 0, 0);
INSERT INTO `u_image_classification_file` VALUES (1234567895, 987654321, 123, 456, 789, '哇哈哈哈5', 2, NULL, NULL, NULL, NULL, '2022-05-29 15:21:25', NULL, NULL, NULL, NULL, 123322154345, '21354345345', '2022-05-29 15:12:10', NULL, NULL, 0, 0);
INSERT INTO `u_image_classification_file` VALUES (1234567896, 987654321, 123, 456, 789, '哇哈哈哈6', 2, NULL, NULL, NULL, NULL, '2022-05-30 15:21:25', NULL, NULL, NULL, NULL, 123322154345, '21354345345', '2022-05-30 15:12:10', NULL, NULL, 0, 0);
INSERT INTO `u_image_classification_file` VALUES (1234567897, 987654321, 123, 456, 789, '哇哈哈哈7', 2, NULL, NULL, NULL, NULL, '2022-05-31 15:21:25', NULL, NULL, NULL, NULL, 123322154345, '21354345345', '2022-05-31 15:12:10', NULL, NULL, 0, 0);
INSERT INTO `u_image_classification_file` VALUES (1234567898, 987654321, 123, 456, 789, '哇哈哈哈8', 2, NULL, NULL, NULL, NULL, '2022-06-01 15:21:25', NULL, NULL, NULL, NULL, 123322154345, '21354345345', '2022-06-01 15:12:10', NULL, NULL, 0, 0);
INSERT INTO `u_image_classification_file` VALUES (1234567899, 987654321, 123, 456, 789, '哇哈哈哈9', 2, NULL, NULL, NULL, NULL, '2022-06-02 15:21:25', NULL, NULL, NULL, NULL, 123322154345, '21354345345', '2022-06-02 15:12:10', NULL, NULL, 0, 0);
INSERT INTO `u_image_classification_file` VALUES (12345678910, 987654321, 123, 456, 789, '哇哈哈哈10', 2, NULL, NULL, NULL, NULL, '2022-06-03 15:21:25', NULL, NULL, NULL, NULL, 123322154345, '21354345345', '2022-06-03 15:12:10', NULL, NULL, 0, 0);
INSERT INTO `u_image_classification_file` VALUES (12345678920, 987654321, 123, 456, 789, '嘿嘿嘿嘿2', 2, NULL, NULL, NULL, NULL, '2021-05-26 15:21:25', NULL, NULL, NULL, NULL, 123322154345, '21354345345', '2021-05-26 15:12:10', NULL, NULL, 0, 0);
INSERT INTO `u_image_classification_file` VALUES (12345678930, 987654321, 123, 456, 789, '嘿嘿嘿嘿3', 2, NULL, NULL, NULL, NULL, '2021-05-27 15:21:25', NULL, NULL, NULL, NULL, 123322154345, '21354345345', '2021-05-27 15:12:10', NULL, NULL, 0, 0);
INSERT INTO `u_image_classification_file` VALUES (12345678940, 987654321, 123, 456, 789, '嘿嘿嘿嘿4', 2, NULL, NULL, NULL, NULL, '2021-05-28 15:21:25', NULL, NULL, NULL, NULL, 123322154345, '21354345345', '2021-05-28 15:12:10', NULL, NULL, 0, 0);
INSERT INTO `u_image_classification_file` VALUES (12345678950, 987654321, 123, 456, 789, '嘿嘿嘿嘿5', 2, NULL, NULL, NULL, NULL, '2021-05-29 15:21:25', NULL, NULL, NULL, NULL, 123322154345, '21354345345', '2021-05-29 15:12:10', NULL, NULL, 0, 0);
INSERT INTO `u_image_classification_file` VALUES (12345678960, 987654321, 123, 456, 789, '嘿嘿嘿嘿6', 2, NULL, NULL, NULL, NULL, '2021-05-30 15:21:25', NULL, NULL, NULL, NULL, 123322154345, '21354345345', '2021-05-30 15:12:10', NULL, NULL, 0, 0);
INSERT INTO `u_image_classification_file` VALUES (12345678970, 987654321, 123, 456, 789, '嘿嘿嘿嘿7', 2, NULL, NULL, NULL, NULL, '2021-05-31 15:21:25', NULL, NULL, NULL, NULL, 123322154345, '21354345345', '2021-05-31 15:12:10', NULL, NULL, 0, 0);
INSERT INTO `u_image_classification_file` VALUES (12345678980, 987654321, 123, 456, 789, '嘿嘿嘿嘿8', 2, NULL, NULL, NULL, NULL, '2021-06-01 15:21:25', NULL, NULL, NULL, NULL, 123322154345, '21354345345', '2021-06-01 15:12:10', NULL, NULL, 0, 0);
INSERT INTO `u_image_classification_file` VALUES (12345678990, 987654321, 123, 456, 789, '嘿嘿嘿嘿9', 2, NULL, NULL, NULL, NULL, '2021-06-02 15:21:25', NULL, NULL, NULL, NULL, 123322154345, '21354345345', '2021-06-02 15:12:10', NULL, NULL, 0, 0);
INSERT INTO `u_image_classification_file` VALUES (123456789100, 987654321, 123, 456, 789, '嘿嘿嘿嘿10', 2, NULL, NULL, NULL, NULL, '2021-06-03 15:21:25', NULL, NULL, NULL, NULL, 123322154345, '21354345345', '2021-06-03 15:12:10', NULL, NULL, 0, 0);
INSERT INTO `u_image_classification_file` VALUES (1234567891000, 987654321, 123, 456, 789, '嘿嘿嘿嘿1', 2, NULL, NULL, NULL, NULL, '2021-05-25 15:21:25', NULL, NULL, NULL, NULL, 123322154345, '21354345345', '2021-05-25 15:12:10', NULL, NULL, 0, 0);

SET FOREIGN_KEY_CHECKS = 1;
