/*
 Navicat Premium Data Transfer

 Source Server         : localhost
 Source Server Type    : MySQL
 Source Server Version : 50651
 Source Host           : localhost:3306
 Source Schema         : bladex

 Target Server Type    : MySQL
 Target Server Version : 50651
 File Encoding         : 65001

 Date: 26/05/2022 11:33:01
*/

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for u_user_opinion_flow
-- ----------------------------
DROP TABLE IF EXISTS `u_user_opinion_flow`;
CREATE TABLE `u_user_opinion_flow`  (
  `id` bigint(64) NOT NULL COMMENT '主键',
  `user_opinion_id` bigint(64) NOT NULL COMMENT 'u_user_opinion表主键',
  `is_current` int(10) NULL DEFAULT NULL COMMENT '是否执行到当前环节，0未执行，1正在执行，2环节结束',
  `reply_name` varchar(20) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '环节名称',
  `reply_content` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '环节内容',
  `manage_time` varchar(30) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '预计处理结束时间',
  `number` int(10) NULL DEFAULT NULL COMMENT '第几次流程，初始为1，触发“不满意并再次提交解决”时在新流程上递增',
  `sort` int(10) NULL DEFAULT NULL COMMENT '流程顺序',
  `manage_user` bigint(64) NULL DEFAULT NULL COMMENT '分配的处理人',
  `manage_user_name` varchar(20) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '分配的处理人姓名',
  `manage_user_phone` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '分配的处理人电话',
  `evaluation` int(10) NULL DEFAULT NULL COMMENT '评价类型，默认null :\r\n1满意，2不满意并再次提交，3不满意并投诉',
  `create_user` bigint(64) NULL DEFAULT NULL COMMENT '创建人',
  `create_dept` bigint(64) NULL DEFAULT NULL COMMENT '创建人所在部门',
  `create_time` datetime NULL DEFAULT NULL COMMENT '创建时间',
  `update_user` bigint(64) NULL DEFAULT NULL COMMENT '修改时间',
  `update_time` datetime NULL DEFAULT NULL COMMENT '修改时间',
  `status` int(10) NULL DEFAULT NULL COMMENT '状态',
  `is_deleted` int(10) NULL DEFAULT NULL COMMENT '是否已删除，默认为0',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci COMMENT = '用户意见处理流程表' ROW_FORMAT = Compact;

-- ----------------------------
-- Records of u_user_opinion_flow
-- ----------------------------
INSERT INTO `u_user_opinion_flow` VALUES (1529648062724288513, 9014360401891442191, 2, '已提交', '已成功提交您的工单信息', NULL, 1, 1, NULL, NULL, NULL, NULL, 1123598821738675201, 1123598813738675201, '2022-05-26 10:18:12', 1123598821738675201, '2022-05-26 10:18:12', 1, 0);
INSERT INTO `u_user_opinion_flow` VALUES (1529648062875283458, 9014360401891442191, 1, '已分配专属客服', '客服：马自达<br>电话：123456789', NULL, 1, 2, 123654, '马自达', '123456789', NULL, 1123598821738675201, 1123598813738675201, '2022-05-26 10:18:12', 1123598821738675201, '2022-05-26 10:18:12', 1, 0);
INSERT INTO `u_user_opinion_flow` VALUES (1529648062942392321, 9014360401891442191, 0, '进入人工预处理环节', '预计2022-05-31之前完成', '2022-05-31', 1, 3, NULL, NULL, NULL, NULL, 1123598821738675201, 1123598813738675201, '2022-05-26 10:18:12', 1123598821738675201, '2022-05-26 10:18:12', 1, 0);
INSERT INTO `u_user_opinion_flow` VALUES (1529648062942392322, 9014360401891442191, 0, '问题已解决', NULL, NULL, 1, 4, NULL, NULL, NULL, NULL, 1123598821738675201, 1123598813738675201, '2022-05-26 10:18:12', 1123598821738675201, '2022-05-26 10:18:12', 1, 0);

SET FOREIGN_KEY_CHECKS = 1;
