package org.springblade.manager.excel;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import com.alibaba.excel.annotation.write.style.ContentRowHeight;
import com.alibaba.excel.annotation.write.style.HeadRowHeight;
import lombok.Data;

import java.io.Serializable;

/**
 * WbsFormElementExcel
 *
 * @author liuyc
 */
@Data
@ColumnWidth(16)
@HeadRowHeight(20)
@ContentRowHeight(18)
public class WbsFormElementBatchExcel implements Serializable {
    private static final long serialVersionUID = 1L;

    /**
     * AID
     */
    @ExcelProperty({"标题", "AID"})
    private String aId;

    /**
     * 表单名
     */
    @ExcelProperty({"标题", "表名"})
    private String tableName;


    /**
     * 表单类型
     */
    @ExcelProperty({"标题", "表类型"})
    private String tableType;

    /**
     * 字段名称
     */
    @ExcelProperty({"标题", "字段名称"})
    private String elementName;

    /**
     * 元素类型
     */
    @ExcelProperty({"标题", "数据类型"})
    private String elementType;

    /**
     * 获取方式
     */
    @ExcelProperty({"标题", "获取方式"})
    private String getMethod;

    /**
     * 元素长度
     */
    @ExcelProperty({"标题", "长度"})
    private String elementLength;

    /**
     * 允许偏差值
     */
    @ExcelProperty({"标题", "允许偏差值"})
    private String elementAllowDeviation;

    /**
     * 检查方法
     */
    @ExcelProperty({"标题", "检查方法和频率"})
    private String elementInspectionMethod;

    /**
     * 是否必填
     */
    @ExcelProperty({"标题", "必填"})
    private String isRequired;

    /**
     * 备注
     */
    @ExcelProperty({"标题", "备注"})
    private String remark;


}
