package org.springblade.manager.feign;

import lombok.AllArgsConstructor;
import org.springblade.manager.entity.ImageClassificationConfig;
import org.springblade.manager.service.IImageClassificationConfigService;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@AllArgsConstructor
public class ImageClassificationConfigClientImpl implements ImageClassificationConfigClient {

    private final IImageClassificationConfigService imageClassificationConfigService;

    @Override
    public List<ImageClassificationConfig> queryClassificationConfigListByIds(List<Long> ids) {
        return this.imageClassificationConfigService.listByIds(ids);
    }

    @Override
    public List<ImageClassificationConfig> queryClassificationConfigList() {
        return this.imageClassificationConfigService.list();
    }
}
