/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.manager.mapper;

import org.apache.ibatis.annotations.Param;
import org.springblade.manager.entity.ExcelTab;
import org.springblade.manager.vo.ExceTabTreVO;
import org.springblade.manager.vo.ExcelTabVO;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.manager.vo.ExcelTabWbsTypeVO;
import org.springblade.manager.vo.WbsTreeVO;

import java.util.List;

/**
 * 清表基础数据表 Mapper 接口
 *
 * @author BladeX
 * @since 2022-05-18
 */
public interface ExcelTabMapper extends BaseMapper<ExcelTab> {

	/**
	 * 自定义分页
	 *
	 * @param page
	 * @param excelTab
	 * @return
	 */
	List<ExcelTabVO> selectExcelTabPage(IPage page, ExcelTabVO excelTab);

	/**
	 * 懒加载获取树形节点
	 *
	 * @param tenantId
	 * @return
	 */
	List<ExceTabTreVO> tabLazyTree(String tenantId, Long modeId,Long parentId);

	List<ExceTabTreVO> tabLazyTreeAll(String tenantId, Long modeId,String name);

	List<ExcelTabWbsTypeVO> getWbsTypeList();

	List<WbsTreeVO> lazyTree(@Param("wbsId") String wbsId,
							 @Param("tenantId") String tenantId,
							 @Param("parentId") Long parentId);
}
