/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.manager.mapper;

import io.lettuce.core.dynamic.annotation.Param;
import org.springblade.manager.entity.ProjectInfo;
import org.springblade.manager.vo.ProjectInfoVO;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.manager.vo.SingPfxManagementVO;

import java.util.List;

/**
 * 客户级项目表 Mapper 接口
 *
 * @author liuyc
 * @since 2022-04-13
 */
public interface ProjectInfoMapper extends BaseMapper<ProjectInfo> {

	List<SingPfxManagementVO> singPfxManagementPage(@Param("current") Long current, @Param("size") Integer size, @Param("vo") SingPfxManagementVO vo);

	List<ProjectInfo> selectProjectList(@Param("projectIds") List<String> projectIds);

	/**
	 * 自定义分页
	 *
	 * @param page
	 * @param projectInfo
	 * @return
	 */
	List<ProjectInfoVO> selectProjectInfoPage(IPage page, ProjectInfoVO projectInfo);


    void updateTemplateIdById(String projectId, String referencePrivateWbsProjectId,String type);

    ProjectInfo selectOneAndWbsTypeById(Long id);
}
