package org.springblade.manager.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;
import org.springblade.manager.dto.WbsTreePrivateDTO2;
import org.springblade.manager.dto.WbsTreePrivateDTO3;
import org.springblade.manager.entity.WbsTree;
import org.springblade.manager.entity.WbsTreePrivate;
import org.springblade.manager.vo.WbsNodeTableVO;
import org.springblade.manager.vo.WbsTreePrivateVO;
import org.springblade.manager.vo.WbsTreeVO;

import java.util.List;


/**
 * Mapper 接口
 *
 * @author liuyc
 * @since 2022-05-24
 */
public interface WbsTreePrivateMapper extends BaseMapper<WbsTreePrivate> {
    List<WbsTreePrivate> selectAll(Integer wbsType);

    /**
     * 获取树形节点
     */
    List<WbsTreePrivateVO> tree(@Param("wbsId") String wbsId,
                                @Param("projectId") String projectId);


    List<WbsTreePrivate> selectByCondition(@Param("id") String id,
                                           @Param("wbsId") String wbsId,
                                           @Param("projectId") String projectId);

    void deleteByCondition(String id, String wbsId, String projectId);

    void deleteByCondition2(String id, String wbsId, String projectId);

    WbsTreePrivate selectByCondition2(String id, String projectId, String wbsId);

    void updateByCondition(String id, String projectId, String wbsId);

    void updateTableByCondition(@Param("id") String id,
                                @Param("projectId") String projectId,
                                @Param("wbsId") String wbsId);

    Integer insertCombination1(@Param("snowId") Long snowId,
                               @Param("wbsTree") WbsTree wbsTree,
                               @Param("wbsType") Integer wbsType,
                               @Param("projectId") String projectId);

    Integer insertCombination2(@Param("snowId") Long snowId,
                               @Param("wbsTree") WbsTreePrivate wbsTree,
                               @Param("projectId") String projectId);

    List<WbsTree> selectIsTable(Long tableId, String projectId);

    List<WbsNodeTableVO> selectByNodeTable(String id, String wbsId, String projectId);

    int updateByCondition1(String id, String wbsId, String projectId);

    List<WbsTreePrivateVO> lazyTree(String wbsId, String tenantId, Long parentId, String projectId);

    int updateByPKeyId(@Param("pKeyId") Long pKeyId, @Param("wbsTP") WbsTreePrivate wbsTP);

    WbsTreePrivate getByCondition(Long parentId, String projectId, String wbsId);

    WbsTreePrivate getByPKeyId(Long pKeyId);

    WbsTreePrivate selectByCondition3(String id, String wbsId, String referencePrivateWbsProjectId);

    WbsTreePrivate selectByPKeyId(Long referenceWbsTemplateId);

    List<WbsTreePrivateDTO2> selectNodeListByCondition(String projectId, String parentId, String wbsId);

    void updateSortById(Long pKeyId, Integer sort);

    void updateSortById2(Long pKeyId, Integer sort);

    int updateIsDeletedByPKeyId(String pKeyId);

    List<WbsTreePrivate> selectNodeAndTable(String id, String wbsId, String referencePrivateWbsProjectId);

    boolean updateBatchByPid(@Param("wbsTreePrivates") WbsTreePrivateDTO3 wbsTreePrivates);
}
