/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.manager.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.manager.dto.FindAllUserByConditionDTO;
import org.springblade.manager.entity.ContractInfo;
import org.springblade.manager.entity.WbsTreeContract;
import org.springblade.manager.vo.*;
import org.springblade.core.mp.base.BaseService;
import org.springblade.system.user.entity.User;
import org.springblade.system.user.vo.UserVO2;


import java.util.List;

/**
 * 合同段信息表 服务类
 *
 * @author liuyc
 * @since 2022-04-14
 */
public interface IContractInfoService extends BaseService<ContractInfo> {

    List<ContractInfo> selectContractByProjectIds(List<Long> ids);

    IPage<ContractInfoVO> selectContractInfoPage(IPage<ContractInfoVO> page, ContractInfoVO contractInfo);

    List<ContractInfo> selectContractInfoPageByPid(String pid);

    List<CRolePostVO> findJobByRoleId(String id);

    IPage<UserVO2> findAllUserByCondition(IPage<UserVO2> page, FindAllUserByConditionDTO values);

    IPage<User> findUserListByCondition(IPage<User> page, FindAllUserByConditionDTO values);

    List<User> findUserInfoByCondition(String rId, String pId, String userName);

    List<User> findUserList();

    Boolean updatePasswordByUserId(String userId, String password);

    String selectStartFileId(String startFileUrl);

    Boolean deleteFile(String url);

    List<WbsTreeContractTreeVO> tree(String wbsId, String projectId, String contractId);

    List<WbsTreeContractVO2> treeTwo(String projectId);

    List<WbsTreeContractTreeVO> queryContractWbsTreeByContractIdAndType(String contractId, Integer wbsType, String parentId);

    List<WbsTreeContractTreeVO> queryContractWbsTreeAll(String contractId, Integer wbsType, String parentId);

    boolean saveAndUpdateContract(ContractInfoVO contractInfo);

    List<ContractInfo> findContractInProject(String ids);

    ContractInfo selectById(String contractId);

    ContractInfoVO2 selectByCondition(ContractInfo contractInfo);

}
