/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.manager.service;

import org.springblade.manager.entity.ExcelTab;
import org.springblade.manager.vo.ExceTabTreVO;
import org.springblade.manager.vo.ExcelTabVO;
import org.springblade.core.mp.base.BaseService;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.manager.vo.ExcelTabWbsTypeVO;
import org.springblade.manager.vo.WbsTreeVO;

import java.util.List;

/**
 * 清表基础数据表 服务类
 *
 * @author BladeX
 * @since 2022-05-18
 */
public interface IExcelTabService extends BaseService<ExcelTab> {

	/**
	 * 自定义分页
	 *
	 * @param page
	 * @param excelTab
	 * @return
	 */
	IPage<ExcelTabVO> selectExcelTabPage(IPage<ExcelTabVO> page, ExcelTabVO excelTab);



	/**
	 * 懒加载树形结构
	 *
	 * @param tenantId
	 * @param modeId
	 * @return
	 */
	List<ExceTabTreVO> tabLazyTree(String tenantId, Long modeId,Long parentId);


	List<ExceTabTreVO> tabLazyTreeAll(String tenantId, Long modeId,String name);


	/**
	 * 获取wbs类型
	 */
	List<ExcelTabWbsTypeVO> getWbsTypeList();

	/**
	 * 懒加载树形结构
	 *
	 * @param tenantId
	 * @param parentId
	 * @return
	 */
	List<WbsTreeVO> lazyTree(String wbsId, String tenantId, Long parentId);
}
