/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.manager.service;

import org.springblade.core.tool.api.R;
import org.springblade.manager.entity.SignPfxFile;
import org.springblade.manager.vo.SignPfxFileVO;
import org.springblade.core.mp.base.BaseService;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.manager.vo.SingPfxManagementVO;

import java.util.List;

/**
 * 个人/企业证书信息表 服务类
 *
 * @author BladeX
 * @since 2022-06-24
 */
public interface ISignPfxFileService extends BaseService<SignPfxFile> {

	IPage<SingPfxManagementVO> singPfxManagementPage(IPage<SingPfxManagementVO> page, SingPfxManagementVO vo);

	/**
	 * 注册
	 */
	R<Boolean> goRegister(Long id);

	/**
	 * 自定义分页
	 */
	IPage<SignPfxFileVO> selectSignPfxFilePage(IPage<SignPfxFileVO> page, SignPfxFileVO signPfxFile);

}
