/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.manager.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.AllArgsConstructor;
import org.springblade.manager.entity.ExctabCell;
import org.springblade.manager.vo.ExctabCellVO;
import org.springblade.manager.mapper.ExctabCellMapper;
import org.springblade.manager.service.IExctabCellService;
import org.springblade.core.mp.base.BaseServiceImpl;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;

import javax.validation.constraints.NotEmpty;
import java.util.List;

/**
 * Excel 结构信息表 服务实现类
 *
 * @author BladeX
 * @since 2022-05-26
 */
@Service
@AllArgsConstructor
public class ExctabCellServiceImpl extends ServiceImpl<ExctabCellMapper, ExctabCell> implements IExctabCellService {


	@Override
	public IPage<ExctabCellVO> selectExctabCellPage(IPage<ExctabCellVO> page, ExctabCellVO exctabCell) {
		return page.setRecords(baseMapper.selectExctabCellPage(page, exctabCell));
	}

}
