/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.manager.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.springblade.manager.entity.ImageClassificationConfig;
import org.springblade.manager.vo.ImageClassificationConfigVO;
import org.springblade.manager.mapper.ImageClassificationConfigMapper;
import org.springblade.manager.service.IImageClassificationConfigService;
import org.springblade.core.mp.base.BaseServiceImpl;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;

import java.util.List;

/**
 * 影像分类配置表 服务实现类
 *
 * @author liuyc
 * @since 2022-05-16
 */
@Service
public class ImageClassificationConfigServiceImpl extends BaseServiceImpl<ImageClassificationConfigMapper, ImageClassificationConfig> implements IImageClassificationConfigService {

	@Override
	public IPage<ImageClassificationConfigVO> selectImageClassificationConfigPage(IPage<ImageClassificationConfigVO> page, ImageClassificationConfigVO imageClassificationConfig) {
		return page.setRecords(baseMapper.selectImageClassificationConfigPage(page, imageClassificationConfig));
	}

	@Override
	public List<ImageClassificationConfig> selectByType(String type) {

		QueryWrapper<ImageClassificationConfig> queryWrapper = new QueryWrapper<>();
		queryWrapper.eq("affiliated_party",type);

		List<ImageClassificationConfig> list = baseMapper.selectList(queryWrapper);
		return list;
	}

}
