/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.manager.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springblade.manager.entity.LinkdataInfo;
import org.springblade.manager.mapper.LinkdataInfoMapper;
import org.springblade.manager.service.ILinkdataInfoService;
import org.springblade.manager.vo.LinkdataInfoVO;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;

import java.util.List;

/**
 * 清表解析字段信息 服务实现类
 *
 * @author BladeX
 * @since 2022-06-17
 */
@Service
public class LinkdataInfoServiceImpl extends ServiceImpl<LinkdataInfoMapper, LinkdataInfo> implements ILinkdataInfoService {

	@Override
	public IPage<LinkdataInfoVO> selectLinkdataInfoPage(IPage<LinkdataInfoVO> page, LinkdataInfoVO linkdataInfo) {
		return page.setRecords(baseMapper.selectLinkdataInfoPage(page, linkdataInfo));
	}

	@Override
	public List<LinkdataInfo> getColSelect(String tabId) {
		return baseMapper.getColSelect(tabId);
	}

}
