package org.springblade.manager.service.impl;

import lombok.AllArgsConstructor;
import org.springblade.core.mp.base.BaseServiceImpl;
import org.springblade.manager.dto.SaveUserInfoByProjectDTO;
import org.springblade.manager.mapper.SaveUserInfoByProjectMapper;
import org.springblade.manager.service.SaveUserInfoByProjectService;
import org.springblade.system.user.entity.User;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 服务实现类
 *
 * @author liuyc
 */
@Service
@AllArgsConstructor
public class SaveUserInfoByProjectServiceImpl
        extends BaseServiceImpl<SaveUserInfoByProjectMapper, SaveUserInfoByProjectDTO>
        implements SaveUserInfoByProjectService {

    @Override
    public List<User> findMaintenanceUser() {
        return this.baseMapper.findMaintenanceUser();
    }

    @Override
    public List<SaveUserInfoByProjectDTO> queryCurrentUserDownAllContractAndProjectId(Long userId) {
        return this.baseMapper.queryCurrentUserDownAllContractAndProjectId(userId);
    }

    @Override
    public List<SaveUserInfoByProjectDTO> queryProjectBusinessUser(Long projectId, Long contractId) {
        return this.baseMapper.queryProjectBusinessUser(projectId, contractId);
    }
}
