/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.manager.wrapper;

import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.manager.entity.ImageClassificationConfig;
import org.springblade.manager.vo.ImageClassificationConfigVO;
import java.util.Objects;

/**
 * 影像分类配置表包装类,返回视图层所需的字段
 *
 * @author BladeX
 * @since 2022-05-16
 */
public class ImageClassificationConfigWrapper extends BaseEntityWrapper<ImageClassificationConfig, ImageClassificationConfigVO>  {

	public static ImageClassificationConfigWrapper build() {
		return new ImageClassificationConfigWrapper();
 	}

	@Override
	public ImageClassificationConfigVO entityVO(ImageClassificationConfig imageClassificationConfig) {
		ImageClassificationConfigVO imageClassificationConfigVO = Objects.requireNonNull(BeanUtil.copy(imageClassificationConfig, ImageClassificationConfigVO.class));

		//User createUser = UserCache.getUser(imageClassificationConfig.getCreateUser());
		//User updateUser = UserCache.getUser(imageClassificationConfig.getUpdateUser());
		//imageClassificationConfigVO.setCreateUserName(createUser.getName());
		//imageClassificationConfigVO.setUpdateUserName(updateUser.getName());

		return imageClassificationConfigVO;
	}

}
