/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.manager.wrapper;

import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.manager.entity.WbsInfo;
import org.springblade.manager.vo.WbsInfoVO;

import java.util.Objects;

/**
 * wbs动态库信息包装类,返回视图层所需的字段
 *
 * @author liuyc
 * @since 2022-04-25
 */
public class WbsInfoWrapper extends BaseEntityWrapper<WbsInfo, WbsInfoVO>  {

	public static WbsInfoWrapper build() {
		return new WbsInfoWrapper();
 	}

	@Override
	public WbsInfoVO entityVO(WbsInfo wbsInfo) {
		WbsInfoVO wbsInfoVO = Objects.requireNonNull(BeanUtil.copy(wbsInfo, WbsInfoVO.class));

		//User createUser = UserCache.getUser(wbsInfo.getCreateUser());
		//User updateUser = UserCache.getUser(wbsInfo.getUpdateUser());
		//wbsInfoVO.setCreateUserName(createUser.getName());
		//wbsInfoVO.setUpdateUserName(updateUser.getName());

		return wbsInfoVO;
	}

}
