/*
 Navicat Premium Data Transfer

 Source Server         : localhost
 Source Server Type    : MySQL
 Source Server Version : 50736
 Source Host           : localhost:3306
 Source Schema         : bladex

 Target Server Type    : MySQL
 Target Server Version : 50736
 File Encoding         : 65001

 Date: 23/05/2022 10:15:01
*/

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for m_contract_info
-- ----------------------------
DROP TABLE IF EXISTS `m_contract_info`;
CREATE TABLE `m_contract_info`  (
  `id` bigint(20) NOT NULL COMMENT '主键id\r\n',
  `p_id` bigint(20) NULL DEFAULT NULL COMMENT '项目id',
  `contract_name` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '合同段名称',
  `contract_type` int(2) NULL DEFAULT NULL COMMENT '合同段类型',
  `contract_number` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '合同段编号',
  `contractor_unit_name` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '业主单位名称',
  `construction_unit_name` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '施工单位名称',
  `supervision_unit_name` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '监理单位名称',
  `contractor_join_time` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '参与方进场时间',
  `plan_start_time` datetime(0) NULL DEFAULT NULL COMMENT '计划开工时间',
  `plan_end_time` datetime(0) NULL DEFAULT NULL COMMENT '计划完工时间',
  `actual_start_time` datetime(0) NULL DEFAULT NULL COMMENT '实际开工时间',
  `actual_end_time` datetime(0) NULL DEFAULT NULL COMMENT '实际完工时间',
  `start_file_url` varchar(2000) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '开工令文件',
  `contract_amount` decimal(20, 2) NULL DEFAULT NULL COMMENT '合同段总金额',
  `project_place` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '合同段工程位置',
  `start_station` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '起始桩号',
  `end_station` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '结束桩号',
  `create_time` datetime(0) NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `create_user` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '创建人',
  `create_dept` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '创建部门',
  `update_user` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '修改人',
  `update_time` datetime(0) NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP(0) COMMENT '修改时间',
  `status` int(2) NULL DEFAULT NULL COMMENT '状态',
  `is_deleted` int(2) NULL DEFAULT 0 COMMENT '是否已删除',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci COMMENT = '合同段信息表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of m_contract_info
-- ----------------------------
SET FOREIGN_KEY_CHECKS = 1;
